=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class BuScheduleRun
    # The globally unique identifier for the object.
    attr_accessor :id

    # The scheduler run ID.  Reference this value for support
    attr_accessor :scheduler_run_id

    # Whether this is an intraday rescheduling run
    attr_accessor :intraday_rescheduling

    # The state of the generation run
    attr_accessor :state

    # The number of weeks spanned by the schedule
    attr_accessor :week_count

    # Percent completion of the schedule run
    attr_accessor :percent_complete

    # The start date of the target week. Dates are represented as an ISO-8601 string. For example: yyyy-MM-dd
    attr_accessor :target_week

    # The generated schedule.  Null unless the schedule run is complete
    attr_accessor :schedule

    # The description of the generated schedule
    attr_accessor :schedule_description

    # When the schedule generation run started. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :scheduling_start_time

    # The user who started the scheduling run
    attr_accessor :scheduling_started_by

    # The user who canceled the scheduling run, if applicable
    attr_accessor :scheduling_canceled_by

    # When the scheduling run was completed, if applicable. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :scheduling_completed_time

    # The number of schedule generation messages for this schedule generation run
    attr_accessor :message_count

    # Rescheduling options for this run.  Null unless intradayRescheduling is true
    attr_accessor :rescheduling_options

    # When the reschedule result will expire.  Null unless intradayRescheduling is true. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :rescheduling_result_expiration

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'scheduler_run_id' => :'schedulerRunId',
        
        :'intraday_rescheduling' => :'intradayRescheduling',
        
        :'state' => :'state',
        
        :'week_count' => :'weekCount',
        
        :'percent_complete' => :'percentComplete',
        
        :'target_week' => :'targetWeek',
        
        :'schedule' => :'schedule',
        
        :'schedule_description' => :'scheduleDescription',
        
        :'scheduling_start_time' => :'schedulingStartTime',
        
        :'scheduling_started_by' => :'schedulingStartedBy',
        
        :'scheduling_canceled_by' => :'schedulingCanceledBy',
        
        :'scheduling_completed_time' => :'schedulingCompletedTime',
        
        :'message_count' => :'messageCount',
        
        :'rescheduling_options' => :'reschedulingOptions',
        
        :'rescheduling_result_expiration' => :'reschedulingResultExpiration',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'id' => :'String',
        
        :'scheduler_run_id' => :'String',
        
        :'intraday_rescheduling' => :'BOOLEAN',
        
        :'state' => :'String',
        
        :'week_count' => :'Integer',
        
        :'percent_complete' => :'Float',
        
        :'target_week' => :'Date',
        
        :'schedule' => :'BuScheduleReference',
        
        :'schedule_description' => :'String',
        
        :'scheduling_start_time' => :'DateTime',
        
        :'scheduling_started_by' => :'UserReference',
        
        :'scheduling_canceled_by' => :'UserReference',
        
        :'scheduling_completed_time' => :'DateTime',
        
        :'message_count' => :'Integer',
        
        :'rescheduling_options' => :'ReschedulingOptionsRunResponse',
        
        :'rescheduling_result_expiration' => :'DateTime',
        
        :'self_uri' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'schedulerRunId')
        
        
        self.scheduler_run_id = attributes[:'schedulerRunId']
        
      
      end

      
      if attributes.has_key?(:'intradayRescheduling')
        
        
        self.intraday_rescheduling = attributes[:'intradayRescheduling']
        
      
      end

      
      if attributes.has_key?(:'state')
        
        
        self.state = attributes[:'state']
        
      
      end

      
      if attributes.has_key?(:'weekCount')
        
        
        self.week_count = attributes[:'weekCount']
        
      
      end

      
      if attributes.has_key?(:'percentComplete')
        
        
        self.percent_complete = attributes[:'percentComplete']
        
      
      end

      
      if attributes.has_key?(:'targetWeek')
        
        
        self.target_week = attributes[:'targetWeek']
        
      
      end

      
      if attributes.has_key?(:'schedule')
        
        
        self.schedule = attributes[:'schedule']
        
      
      end

      
      if attributes.has_key?(:'scheduleDescription')
        
        
        self.schedule_description = attributes[:'scheduleDescription']
        
      
      end

      
      if attributes.has_key?(:'schedulingStartTime')
        
        
        self.scheduling_start_time = attributes[:'schedulingStartTime']
        
      
      end

      
      if attributes.has_key?(:'schedulingStartedBy')
        
        
        self.scheduling_started_by = attributes[:'schedulingStartedBy']
        
      
      end

      
      if attributes.has_key?(:'schedulingCanceledBy')
        
        
        self.scheduling_canceled_by = attributes[:'schedulingCanceledBy']
        
      
      end

      
      if attributes.has_key?(:'schedulingCompletedTime')
        
        
        self.scheduling_completed_time = attributes[:'schedulingCompletedTime']
        
      
      end

      
      if attributes.has_key?(:'messageCount')
        
        
        self.message_count = attributes[:'messageCount']
        
      
      end

      
      if attributes.has_key?(:'reschedulingOptions')
        
        
        self.rescheduling_options = attributes[:'reschedulingOptions']
        
      
      end

      
      if attributes.has_key?(:'reschedulingResultExpiration')
        
        
        self.rescheduling_result_expiration = attributes[:'reschedulingResultExpiration']
        
      
      end

      
      if attributes.has_key?(:'selfUri')
        
        
        self.self_uri = attributes[:'selfUri']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["None", "Queued", "Scheduling", "Canceled", "Failed", "Complete"]
      if @state && !allowed_values.include?(@state)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] state Object to be assigned
    def state=(state)
      allowed_values = ["None", "Queued", "Scheduling", "Canceled", "Failed", "Complete"]
      if state && !allowed_values.include?(state)
        fail ArgumentError, "invalid value for 'state', must be one of #{allowed_values}."
      end
      @state = state
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          scheduler_run_id == o.scheduler_run_id &&
          intraday_rescheduling == o.intraday_rescheduling &&
          state == o.state &&
          week_count == o.week_count &&
          percent_complete == o.percent_complete &&
          target_week == o.target_week &&
          schedule == o.schedule &&
          schedule_description == o.schedule_description &&
          scheduling_start_time == o.scheduling_start_time &&
          scheduling_started_by == o.scheduling_started_by &&
          scheduling_canceled_by == o.scheduling_canceled_by &&
          scheduling_completed_time == o.scheduling_completed_time &&
          message_count == o.message_count &&
          rescheduling_options == o.rescheduling_options &&
          rescheduling_result_expiration == o.rescheduling_result_expiration &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, scheduler_run_id, intraday_rescheduling, state, week_count, percent_complete, target_week, schedule, schedule_description, scheduling_start_time, scheduling_started_by, scheduling_canceled_by, scheduling_completed_time, message_count, rescheduling_options, rescheduling_result_expiration, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
