=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  # Create Management Unit
  class CreateManagementUnitApiRequest
    # The name of the management unit
    attr_accessor :name

    # The default time zone to use for this management unit.  Moving to Business Unit
    attr_accessor :time_zone

    # The configured first day of the week for scheduling and forecasting purposes. Moving to Business Unit
    attr_accessor :start_day_of_week

    # The configuration for the management unit.  If omitted, reasonable defaults will be assigned
    attr_accessor :settings

    # The id of the division to which this management unit belongs.  Defaults to home division ID
    attr_accessor :division_id

    # The id of the business unit to which this management unit belongs.  Required after business unit launch
    attr_accessor :business_unit_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'name' => :'name',
        
        :'time_zone' => :'timeZone',
        
        :'start_day_of_week' => :'startDayOfWeek',
        
        :'settings' => :'settings',
        
        :'division_id' => :'divisionId',
        
        :'business_unit_id' => :'businessUnitId'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'name' => :'String',
        
        :'time_zone' => :'String',
        
        :'start_day_of_week' => :'String',
        
        :'settings' => :'CreateManagementUnitSettingsRequest',
        
        :'division_id' => :'String',
        
        :'business_unit_id' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'timeZone')
        
        
        self.time_zone = attributes[:'timeZone']
        
      
      end

      
      if attributes.has_key?(:'startDayOfWeek')
        
        
        self.start_day_of_week = attributes[:'startDayOfWeek']
        
      
      end

      
      if attributes.has_key?(:'settings')
        
        
        self.settings = attributes[:'settings']
        
      
      end

      
      if attributes.has_key?(:'divisionId')
        
        
        self.division_id = attributes[:'divisionId']
        
      
      end

      
      if attributes.has_key?(:'businessUnitId')
        
        
        self.business_unit_id = attributes[:'businessUnitId']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      if @name.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      allowed_values = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
      if @start_day_of_week && !allowed_values.include?(@start_day_of_week)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      if @business_unit_id.nil?
        return false
      end

      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] start_day_of_week Object to be assigned
    def start_day_of_week=(start_day_of_week)
      allowed_values = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"]
      if start_day_of_week && !allowed_values.include?(start_day_of_week)
        fail ArgumentError, "invalid value for 'start_day_of_week', must be one of #{allowed_values}."
      end
      @start_day_of_week = start_day_of_week
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          time_zone == o.time_zone &&
          start_day_of_week == o.start_day_of_week &&
          settings == o.settings &&
          division_id == o.division_id &&
          business_unit_id == o.business_unit_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [name, time_zone, start_day_of_week, settings, division_id, business_unit_id].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
