=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class HistoricalAdherenceDayMetrics
    # Start of day offset in seconds relative to query start time
    attr_accessor :day_start_offset_secs

    # Duration of schedule in seconds included for adherence percentage calculation
    attr_accessor :adherence_schedule_secs

    # Total scheduled duration in seconds for OnQueue activities
    attr_accessor :conformance_schedule_secs

    # Total actually worked duration in seconds for OnQueue activities
    attr_accessor :conformance_actual_secs

    # Total number of adherence exceptions for this user
    attr_accessor :exception_count

    # Total duration in seconds of adherence exceptions for this user
    attr_accessor :exception_duration_secs

    # The impact duration in seconds of current adherence state for this user
    attr_accessor :impact_seconds

    # Total duration in seconds for all scheduled activities
    attr_accessor :schedule_length_secs

    # Total duration in seconds for all actually worked activities
    attr_accessor :actual_length_secs

    # Total adherence percentage for this user, in the scale of 0 - 100
    attr_accessor :adherence_percentage

    # Total conformance percentage for this user, in the scale of 0 - 100. Conformance percentage can be greater than 100 when the actual on queue time is greater than the scheduled on queue time for the same period.
    attr_accessor :conformance_percentage

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'day_start_offset_secs' => :'dayStartOffsetSecs',
        
        :'adherence_schedule_secs' => :'adherenceScheduleSecs',
        
        :'conformance_schedule_secs' => :'conformanceScheduleSecs',
        
        :'conformance_actual_secs' => :'conformanceActualSecs',
        
        :'exception_count' => :'exceptionCount',
        
        :'exception_duration_secs' => :'exceptionDurationSecs',
        
        :'impact_seconds' => :'impactSeconds',
        
        :'schedule_length_secs' => :'scheduleLengthSecs',
        
        :'actual_length_secs' => :'actualLengthSecs',
        
        :'adherence_percentage' => :'adherencePercentage',
        
        :'conformance_percentage' => :'conformancePercentage'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'day_start_offset_secs' => :'Integer',
        
        :'adherence_schedule_secs' => :'Integer',
        
        :'conformance_schedule_secs' => :'Integer',
        
        :'conformance_actual_secs' => :'Integer',
        
        :'exception_count' => :'Integer',
        
        :'exception_duration_secs' => :'Integer',
        
        :'impact_seconds' => :'Integer',
        
        :'schedule_length_secs' => :'Integer',
        
        :'actual_length_secs' => :'Integer',
        
        :'adherence_percentage' => :'Float',
        
        :'conformance_percentage' => :'Float'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'dayStartOffsetSecs')
        
        
        self.day_start_offset_secs = attributes[:'dayStartOffsetSecs']
        
      
      end

      
      if attributes.has_key?(:'adherenceScheduleSecs')
        
        
        self.adherence_schedule_secs = attributes[:'adherenceScheduleSecs']
        
      
      end

      
      if attributes.has_key?(:'conformanceScheduleSecs')
        
        
        self.conformance_schedule_secs = attributes[:'conformanceScheduleSecs']
        
      
      end

      
      if attributes.has_key?(:'conformanceActualSecs')
        
        
        self.conformance_actual_secs = attributes[:'conformanceActualSecs']
        
      
      end

      
      if attributes.has_key?(:'exceptionCount')
        
        
        self.exception_count = attributes[:'exceptionCount']
        
      
      end

      
      if attributes.has_key?(:'exceptionDurationSecs')
        
        
        self.exception_duration_secs = attributes[:'exceptionDurationSecs']
        
      
      end

      
      if attributes.has_key?(:'impactSeconds')
        
        
        self.impact_seconds = attributes[:'impactSeconds']
        
      
      end

      
      if attributes.has_key?(:'scheduleLengthSecs')
        
        
        self.schedule_length_secs = attributes[:'scheduleLengthSecs']
        
      
      end

      
      if attributes.has_key?(:'actualLengthSecs')
        
        
        self.actual_length_secs = attributes[:'actualLengthSecs']
        
      
      end

      
      if attributes.has_key?(:'adherencePercentage')
        
        
        self.adherence_percentage = attributes[:'adherencePercentage']
        
      
      end

      
      if attributes.has_key?(:'conformancePercentage')
        
        
        self.conformance_percentage = attributes[:'conformancePercentage']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          day_start_offset_secs == o.day_start_offset_secs &&
          adherence_schedule_secs == o.adherence_schedule_secs &&
          conformance_schedule_secs == o.conformance_schedule_secs &&
          conformance_actual_secs == o.conformance_actual_secs &&
          exception_count == o.exception_count &&
          exception_duration_secs == o.exception_duration_secs &&
          impact_seconds == o.impact_seconds &&
          schedule_length_secs == o.schedule_length_secs &&
          actual_length_secs == o.actual_length_secs &&
          adherence_percentage == o.adherence_percentage &&
          conformance_percentage == o.conformance_percentage
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [day_start_offset_secs, adherence_schedule_secs, conformance_schedule_secs, conformance_actual_secs, exception_count, exception_duration_secs, impact_seconds, schedule_length_secs, actual_length_secs, adherence_percentage, conformance_percentage].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
