=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class HistoricalAdherenceQueryResult
    # The ID of the user for whom the adherence is queried
    attr_accessor :user_id

    # Beginning of the date range that was queried, in ISO-8601 format
    attr_accessor :start_date

    # End of the date range that was queried, in ISO-8601 format. If it was not set, end date will be set to the queried time
    attr_accessor :end_date

    # Adherence percentage for this user, in the scale of 0 - 100
    attr_accessor :adherence_percentage

    # Conformance percentage for this user, in the scale of 0 - 100. Conformance percentage can be greater than 100 when the actual on queue time is greater than the scheduled on queue time for the same period.
    attr_accessor :conformance_percentage

    # The impact of the current adherence state for this user
    attr_accessor :impact

    # List of adherence exceptions for this user
    attr_accessor :exception_info

    # Adherence and conformance metrics for days in query range
    attr_accessor :day_metrics

    # List of actual activity with offset for this user
    attr_accessor :actuals

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'user_id' => :'userId',
        
        :'start_date' => :'startDate',
        
        :'end_date' => :'endDate',
        
        :'adherence_percentage' => :'adherencePercentage',
        
        :'conformance_percentage' => :'conformancePercentage',
        
        :'impact' => :'impact',
        
        :'exception_info' => :'exceptionInfo',
        
        :'day_metrics' => :'dayMetrics',
        
        :'actuals' => :'actuals'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'user_id' => :'String',
        
        :'start_date' => :'DateTime',
        
        :'end_date' => :'DateTime',
        
        :'adherence_percentage' => :'Float',
        
        :'conformance_percentage' => :'Float',
        
        :'impact' => :'String',
        
        :'exception_info' => :'Array<HistoricalAdherenceExceptionInfo>',
        
        :'day_metrics' => :'Array<HistoricalAdherenceDayMetrics>',
        
        :'actuals' => :'Array<HistoricalAdherenceActuals>'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'userId')
        
        
        self.user_id = attributes[:'userId']
        
      
      end

      
      if attributes.has_key?(:'startDate')
        
        
        self.start_date = attributes[:'startDate']
        
      
      end

      
      if attributes.has_key?(:'endDate')
        
        
        self.end_date = attributes[:'endDate']
        
      
      end

      
      if attributes.has_key?(:'adherencePercentage')
        
        
        self.adherence_percentage = attributes[:'adherencePercentage']
        
      
      end

      
      if attributes.has_key?(:'conformancePercentage')
        
        
        self.conformance_percentage = attributes[:'conformancePercentage']
        
      
      end

      
      if attributes.has_key?(:'impact')
        
        
        self.impact = attributes[:'impact']
        
      
      end

      
      if attributes.has_key?(:'exceptionInfo')
        
        if (value = attributes[:'exceptionInfo']).is_a?(Array)
          self.exception_info = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'dayMetrics')
        
        if (value = attributes[:'dayMetrics']).is_a?(Array)
          self.day_metrics = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'actuals')
        
        if (value = attributes[:'actuals']).is_a?(Array)
          self.actuals = value
        end
        
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["Positive", "Negative", "Neutral", "Unknown"]
      if @impact && !allowed_values.include?(@impact)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] impact Object to be assigned
    def impact=(impact)
      allowed_values = ["Positive", "Negative", "Neutral", "Unknown"]
      if impact && !allowed_values.include?(impact)
        fail ArgumentError, "invalid value for 'impact', must be one of #{allowed_values}."
      end
      @impact = impact
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          user_id == o.user_id &&
          start_date == o.start_date &&
          end_date == o.end_date &&
          adherence_percentage == o.adherence_percentage &&
          conformance_percentage == o.conformance_percentage &&
          impact == o.impact &&
          exception_info == o.exception_info &&
          day_metrics == o.day_metrics &&
          actuals == o.actuals
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [user_id, start_date, end_date, adherence_percentage, conformance_percentage, impact, exception_info, day_metrics, actuals].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
