=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class MessagingCampaign
    # The globally unique identifier for the object.
    attr_accessor :id

    attr_accessor :name

    # Creation time of the entity. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_created

    # Last modified time of the entity. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_modified

    # Required for updates, must match the version number of the most recent update
    attr_accessor :version

    # The division this entity belongs to.
    attr_accessor :division

    # The current status of the messaging campaign. A messaging campaign may be turned 'on' or 'off'.
    attr_accessor :campaign_status

    # The callable time set for this messaging campaign.
    attr_accessor :callable_time_set

    # The contact list that this messaging campaign will send messages for.
    attr_accessor :contact_list

    # The dnc lists to check before sending a message for this messaging campaign.
    attr_accessor :dnc_lists

    # Whether this messaging campaign is always running
    attr_accessor :always_running

    # The order in which to sort contacts for dialing, based on up to four columns.
    attr_accessor :contact_sorts

    # How many messages this messaging campaign will send per minute.
    attr_accessor :messages_per_minute

    # A list of current error conditions associated with this messaging campaign.
    attr_accessor :errors

    # Configuration for this messaging campaign to send SMS messages.
    attr_accessor :sms_config

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'date_created' => :'dateCreated',
        
        :'date_modified' => :'dateModified',
        
        :'version' => :'version',
        
        :'division' => :'division',
        
        :'campaign_status' => :'campaignStatus',
        
        :'callable_time_set' => :'callableTimeSet',
        
        :'contact_list' => :'contactList',
        
        :'dnc_lists' => :'dncLists',
        
        :'always_running' => :'alwaysRunning',
        
        :'contact_sorts' => :'contactSorts',
        
        :'messages_per_minute' => :'messagesPerMinute',
        
        :'errors' => :'errors',
        
        :'sms_config' => :'smsConfig',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'id' => :'String',
        
        :'name' => :'String',
        
        :'date_created' => :'DateTime',
        
        :'date_modified' => :'DateTime',
        
        :'version' => :'Integer',
        
        :'division' => :'DomainEntityRef',
        
        :'campaign_status' => :'String',
        
        :'callable_time_set' => :'DomainEntityRef',
        
        :'contact_list' => :'DomainEntityRef',
        
        :'dnc_lists' => :'Array<DomainEntityRef>',
        
        :'always_running' => :'BOOLEAN',
        
        :'contact_sorts' => :'Array<ContactSort>',
        
        :'messages_per_minute' => :'Integer',
        
        :'errors' => :'Array<RestErrorDetail>',
        
        :'sms_config' => :'SmsConfig',
        
        :'self_uri' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'dateCreated')
        
        
        self.date_created = attributes[:'dateCreated']
        
      
      end

      
      if attributes.has_key?(:'dateModified')
        
        
        self.date_modified = attributes[:'dateModified']
        
      
      end

      
      if attributes.has_key?(:'version')
        
        
        self.version = attributes[:'version']
        
      
      end

      
      if attributes.has_key?(:'division')
        
        
        self.division = attributes[:'division']
        
      
      end

      
      if attributes.has_key?(:'campaignStatus')
        
        
        self.campaign_status = attributes[:'campaignStatus']
        
      
      end

      
      if attributes.has_key?(:'callableTimeSet')
        
        
        self.callable_time_set = attributes[:'callableTimeSet']
        
      
      end

      
      if attributes.has_key?(:'contactList')
        
        
        self.contact_list = attributes[:'contactList']
        
      
      end

      
      if attributes.has_key?(:'dncLists')
        
        if (value = attributes[:'dncLists']).is_a?(Array)
          self.dnc_lists = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'alwaysRunning')
        
        
        self.always_running = attributes[:'alwaysRunning']
        
      
      end

      
      if attributes.has_key?(:'contactSorts')
        
        if (value = attributes[:'contactSorts']).is_a?(Array)
          self.contact_sorts = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'messagesPerMinute')
        
        
        self.messages_per_minute = attributes[:'messagesPerMinute']
        
      
      end

      
      if attributes.has_key?(:'errors')
        
        if (value = attributes[:'errors']).is_a?(Array)
          self.errors = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'smsConfig')
        
        
        self.sms_config = attributes[:'smsConfig']
        
      
      end

      
      if attributes.has_key?(:'selfUri')
        
        
        self.self_uri = attributes[:'selfUri']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["on", "stopping", "off", "complete", "invalid"]
      if @campaign_status && !allowed_values.include?(@campaign_status)
        return false
      end
      
      
      
      
      
      
      
      
      if @contact_list.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      if @messages_per_minute.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] campaign_status Object to be assigned
    def campaign_status=(campaign_status)
      allowed_values = ["on", "stopping", "off", "complete", "invalid"]
      if campaign_status && !allowed_values.include?(campaign_status)
        fail ArgumentError, "invalid value for 'campaign_status', must be one of #{allowed_values}."
      end
      @campaign_status = campaign_status
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          date_created == o.date_created &&
          date_modified == o.date_modified &&
          version == o.version &&
          division == o.division &&
          campaign_status == o.campaign_status &&
          callable_time_set == o.callable_time_set &&
          contact_list == o.contact_list &&
          dnc_lists == o.dnc_lists &&
          always_running == o.always_running &&
          contact_sorts == o.contact_sorts &&
          messages_per_minute == o.messages_per_minute &&
          errors == o.errors &&
          sms_config == o.sms_config &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, date_created, date_modified, version, division, campaign_status, callable_time_set, contact_list, dnc_lists, always_running, contact_sorts, messages_per_minute, errors, sms_config, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
