=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class ObservationValue
    # The time at which the observation occurred. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :observation_date

    # Unique identifier for the conversation
    attr_accessor :conversation_id

    # The unique identifier of this session
    attr_accessor :session_id

    # Unique identifier for a skill requested for an interaction
    attr_accessor :requested_routing_skill_ids

    # Unique identifier for the language requested for an interaction
    attr_accessor :requested_language_id

    # Routing priority for the current interaction
    attr_accessor :routing_priority

    # A human readable name identifying the participant
    attr_accessor :participant_name

    # Unique identifier for the user
    attr_accessor :user_id

    # The direction of the communication
    attr_accessor :direction

    # Session media type that was converted from in case of a media type conversion
    attr_accessor :converted_from

    # Session media type that was converted to in case of a media type conversion
    attr_accessor :converted_to

    # The address that initiated an action
    attr_accessor :address_from

    # The address receiving an action
    attr_accessor :address_to

    # Automatic Number Identification (caller's number)
    attr_accessor :ani

    # Dialed number identification service (number dialed by the calling party)
    attr_accessor :dnis

    # The team id the user is a member of
    attr_accessor :team_id

    # All routing types for requested/attempted routing methods
    attr_accessor :requested_routings

    # Complete routing method
    attr_accessor :used_routing

    attr_accessor :scored_agents

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'observation_date' => :'observationDate',
        
        :'conversation_id' => :'conversationId',
        
        :'session_id' => :'sessionId',
        
        :'requested_routing_skill_ids' => :'requestedRoutingSkillIds',
        
        :'requested_language_id' => :'requestedLanguageId',
        
        :'routing_priority' => :'routingPriority',
        
        :'participant_name' => :'participantName',
        
        :'user_id' => :'userId',
        
        :'direction' => :'direction',
        
        :'converted_from' => :'convertedFrom',
        
        :'converted_to' => :'convertedTo',
        
        :'address_from' => :'addressFrom',
        
        :'address_to' => :'addressTo',
        
        :'ani' => :'ani',
        
        :'dnis' => :'dnis',
        
        :'team_id' => :'teamId',
        
        :'requested_routings' => :'requestedRoutings',
        
        :'used_routing' => :'usedRouting',
        
        :'scored_agents' => :'scoredAgents'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'observation_date' => :'DateTime',
        
        :'conversation_id' => :'String',
        
        :'session_id' => :'String',
        
        :'requested_routing_skill_ids' => :'Array<String>',
        
        :'requested_language_id' => :'String',
        
        :'routing_priority' => :'Integer',
        
        :'participant_name' => :'String',
        
        :'user_id' => :'String',
        
        :'direction' => :'String',
        
        :'converted_from' => :'String',
        
        :'converted_to' => :'String',
        
        :'address_from' => :'String',
        
        :'address_to' => :'String',
        
        :'ani' => :'String',
        
        :'dnis' => :'String',
        
        :'team_id' => :'String',
        
        :'requested_routings' => :'Array<String>',
        
        :'used_routing' => :'String',
        
        :'scored_agents' => :'Array<AnalyticsScoredAgent>'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'observationDate')
        
        
        self.observation_date = attributes[:'observationDate']
        
      
      end

      
      if attributes.has_key?(:'conversationId')
        
        
        self.conversation_id = attributes[:'conversationId']
        
      
      end

      
      if attributes.has_key?(:'sessionId')
        
        
        self.session_id = attributes[:'sessionId']
        
      
      end

      
      if attributes.has_key?(:'requestedRoutingSkillIds')
        
        if (value = attributes[:'requestedRoutingSkillIds']).is_a?(Array)
          self.requested_routing_skill_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'requestedLanguageId')
        
        
        self.requested_language_id = attributes[:'requestedLanguageId']
        
      
      end

      
      if attributes.has_key?(:'routingPriority')
        
        
        self.routing_priority = attributes[:'routingPriority']
        
      
      end

      
      if attributes.has_key?(:'participantName')
        
        
        self.participant_name = attributes[:'participantName']
        
      
      end

      
      if attributes.has_key?(:'userId')
        
        
        self.user_id = attributes[:'userId']
        
      
      end

      
      if attributes.has_key?(:'direction')
        
        
        self.direction = attributes[:'direction']
        
      
      end

      
      if attributes.has_key?(:'convertedFrom')
        
        
        self.converted_from = attributes[:'convertedFrom']
        
      
      end

      
      if attributes.has_key?(:'convertedTo')
        
        
        self.converted_to = attributes[:'convertedTo']
        
      
      end

      
      if attributes.has_key?(:'addressFrom')
        
        
        self.address_from = attributes[:'addressFrom']
        
      
      end

      
      if attributes.has_key?(:'addressTo')
        
        
        self.address_to = attributes[:'addressTo']
        
      
      end

      
      if attributes.has_key?(:'ani')
        
        
        self.ani = attributes[:'ani']
        
      
      end

      
      if attributes.has_key?(:'dnis')
        
        
        self.dnis = attributes[:'dnis']
        
      
      end

      
      if attributes.has_key?(:'teamId')
        
        
        self.team_id = attributes[:'teamId']
        
      
      end

      
      if attributes.has_key?(:'requestedRoutings')
        
        if (value = attributes[:'requestedRoutings']).is_a?(Array)
          self.requested_routings = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'usedRouting')
        
        
        self.used_routing = attributes[:'usedRouting']
        
      
      end

      
      if attributes.has_key?(:'scoredAgents')
        
        if (value = attributes[:'scoredAgents']).is_a?(Array)
          self.scored_agents = value
        end
        
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      if @observation_date.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["inbound", "outbound"]
      if @direction && !allowed_values.include?(@direction)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["Predictive", "Preferred", "Manual", "Last", "Bullseye", "Standard"]
      if @used_routing && !allowed_values.include?(@used_routing)
        return false
      end
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] direction Object to be assigned
    def direction=(direction)
      allowed_values = ["inbound", "outbound"]
      if direction && !allowed_values.include?(direction)
        fail ArgumentError, "invalid value for 'direction', must be one of #{allowed_values}."
      end
      @direction = direction
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] used_routing Object to be assigned
    def used_routing=(used_routing)
      allowed_values = ["Predictive", "Preferred", "Manual", "Last", "Bullseye", "Standard"]
      if used_routing && !allowed_values.include?(used_routing)
        fail ArgumentError, "invalid value for 'used_routing', must be one of #{allowed_values}."
      end
      @used_routing = used_routing
    end

    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          observation_date == o.observation_date &&
          conversation_id == o.conversation_id &&
          session_id == o.session_id &&
          requested_routing_skill_ids == o.requested_routing_skill_ids &&
          requested_language_id == o.requested_language_id &&
          routing_priority == o.routing_priority &&
          participant_name == o.participant_name &&
          user_id == o.user_id &&
          direction == o.direction &&
          converted_from == o.converted_from &&
          converted_to == o.converted_to &&
          address_from == o.address_from &&
          address_to == o.address_to &&
          ani == o.ani &&
          dnis == o.dnis &&
          team_id == o.team_id &&
          requested_routings == o.requested_routings &&
          used_routing == o.used_routing &&
          scored_agents == o.scored_agents
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [observation_date, conversation_id, session_id, requested_routing_skill_ids, requested_language_id, routing_priority, participant_name, user_id, direction, converted_from, converted_to, address_from, address_to, ani, dnis, team_id, requested_routings, used_routing, scored_agents].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
