=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class PostTextResponse
    # The state of the bot after completion of the request
    attr_accessor :bot_state

    # The list of messages to respond with, if any
    attr_accessor :reply_messages

    # The name of the intent the bot is either processing or has processed, this will be blank if no intent could be detected.
    attr_accessor :intent_name

    # Data parameters detected and filled by the bot.
    attr_accessor :slots

    # The optional ID specified in the request
    attr_accessor :bot_correlation_id

    # Raw data response from AWS (if called)
    attr_accessor :amazon_lex

    # Raw data response from Google Dialogflow (if called)
    attr_accessor :google_dialog_flow

    # Raw data response from Genesys' Dialogengine (if called)
    attr_accessor :genesys_dialog_engine

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'bot_state' => :'botState',
        
        :'reply_messages' => :'replyMessages',
        
        :'intent_name' => :'intentName',
        
        :'slots' => :'slots',
        
        :'bot_correlation_id' => :'botCorrelationId',
        
        :'amazon_lex' => :'amazonLex',
        
        :'google_dialog_flow' => :'googleDialogFlow',
        
        :'genesys_dialog_engine' => :'genesysDialogEngine'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'bot_state' => :'String',
        
        :'reply_messages' => :'Array<PostTextMessage>',
        
        :'intent_name' => :'String',
        
        :'slots' => :'Hash<String, String>',
        
        :'bot_correlation_id' => :'String',
        
        :'amazon_lex' => :'Hash<String, Object>',
        
        :'google_dialog_flow' => :'Hash<String, Object>',
        
        :'genesys_dialog_engine' => :'Hash<String, Object>'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'botState')
        
        
        self.bot_state = attributes[:'botState']
        
      
      end

      
      if attributes.has_key?(:'replyMessages')
        
        if (value = attributes[:'replyMessages']).is_a?(Array)
          self.reply_messages = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'intentName')
        
        
        self.intent_name = attributes[:'intentName']
        
      
      end

      
      if attributes.has_key?(:'slots')
        
        if (value = attributes[:'slots']).is_a?(Array)
          self.slots = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'botCorrelationId')
        
        
        self.bot_correlation_id = attributes[:'botCorrelationId']
        
      
      end

      
      if attributes.has_key?(:'amazonLex')
        
        if (value = attributes[:'amazonLex']).is_a?(Array)
          self.amazon_lex = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'googleDialogFlow')
        
        if (value = attributes[:'googleDialogFlow']).is_a?(Array)
          self.google_dialog_flow = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'genesysDialogEngine')
        
        if (value = attributes[:'genesysDialogEngine']).is_a?(Array)
          self.genesys_dialog_engine = value
        end
        
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      if @bot_state.nil?
        return false
      end

      
      
      allowed_values = ["Complete", "Failed", "MoreData"]
      if @bot_state && !allowed_values.include?(@bot_state)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] bot_state Object to be assigned
    def bot_state=(bot_state)
      allowed_values = ["Complete", "Failed", "MoreData"]
      if bot_state && !allowed_values.include?(bot_state)
        fail ArgumentError, "invalid value for 'bot_state', must be one of #{allowed_values}."
      end
      @bot_state = bot_state
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          bot_state == o.bot_state &&
          reply_messages == o.reply_messages &&
          intent_name == o.intent_name &&
          slots == o.slots &&
          bot_correlation_id == o.bot_correlation_id &&
          amazon_lex == o.amazon_lex &&
          google_dialog_flow == o.google_dialog_flow &&
          genesys_dialog_engine == o.genesys_dialog_engine
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [bot_state, reply_messages, intent_name, slots, bot_correlation_id, amazon_lex, google_dialog_flow, genesys_dialog_engine].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
