=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  # Schedule generation warning
  class ScheduleGenerationWarning
    # ID of the user in the warning
    attr_accessor :user_id

    # Whether the user does not have the appropriate license to be scheduled
    attr_accessor :user_not_licensed

    # Whether the number of scheduled days exceeded the maximum days to schedule defined in the agent work plan
    attr_accessor :unable_to_meet_max_days

    # Days indicated as required to work in agent work plan where no viable shift was found to schedule
    attr_accessor :unable_to_schedule_required_days

    # Whether the schedule did not meet the minimum paid time for the week defined in the agent work plan
    attr_accessor :unable_to_meet_min_paid_for_the_week

    # Whether the schedule exceeded the maximum paid time for the week defined in the agent work plan
    attr_accessor :unable_to_meet_max_paid_for_the_week

    # Days agent was scheduled but there was no need to meet. The scheduled days have no effect on service levels
    attr_accessor :no_need_days

    # Whether the schedule did not meet the minimum time between shifts defined in the agent work plan
    attr_accessor :shifts_too_close_together

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'user_id' => :'userId',
        
        :'user_not_licensed' => :'userNotLicensed',
        
        :'unable_to_meet_max_days' => :'unableToMeetMaxDays',
        
        :'unable_to_schedule_required_days' => :'unableToScheduleRequiredDays',
        
        :'unable_to_meet_min_paid_for_the_week' => :'unableToMeetMinPaidForTheWeek',
        
        :'unable_to_meet_max_paid_for_the_week' => :'unableToMeetMaxPaidForTheWeek',
        
        :'no_need_days' => :'noNeedDays',
        
        :'shifts_too_close_together' => :'shiftsTooCloseTogether'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'user_id' => :'String',
        
        :'user_not_licensed' => :'BOOLEAN',
        
        :'unable_to_meet_max_days' => :'BOOLEAN',
        
        :'unable_to_schedule_required_days' => :'Array<String>',
        
        :'unable_to_meet_min_paid_for_the_week' => :'BOOLEAN',
        
        :'unable_to_meet_max_paid_for_the_week' => :'BOOLEAN',
        
        :'no_need_days' => :'Array<String>',
        
        :'shifts_too_close_together' => :'BOOLEAN'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'userId')
        
        
        self.user_id = attributes[:'userId']
        
      
      end

      
      if attributes.has_key?(:'userNotLicensed')
        
        
        self.user_not_licensed = attributes[:'userNotLicensed']
        
      
      end

      
      if attributes.has_key?(:'unableToMeetMaxDays')
        
        
        self.unable_to_meet_max_days = attributes[:'unableToMeetMaxDays']
        
      
      end

      
      if attributes.has_key?(:'unableToScheduleRequiredDays')
        
        if (value = attributes[:'unableToScheduleRequiredDays']).is_a?(Array)
          self.unable_to_schedule_required_days = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'unableToMeetMinPaidForTheWeek')
        
        
        self.unable_to_meet_min_paid_for_the_week = attributes[:'unableToMeetMinPaidForTheWeek']
        
      
      end

      
      if attributes.has_key?(:'unableToMeetMaxPaidForTheWeek')
        
        
        self.unable_to_meet_max_paid_for_the_week = attributes[:'unableToMeetMaxPaidForTheWeek']
        
      
      end

      
      if attributes.has_key?(:'noNeedDays')
        
        if (value = attributes[:'noNeedDays']).is_a?(Array)
          self.no_need_days = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'shiftsTooCloseTogether')
        
        
        self.shifts_too_close_together = attributes[:'shiftsTooCloseTogether']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          user_id == o.user_id &&
          user_not_licensed == o.user_not_licensed &&
          unable_to_meet_max_days == o.unable_to_meet_max_days &&
          unable_to_schedule_required_days == o.unable_to_schedule_required_days &&
          unable_to_meet_min_paid_for_the_week == o.unable_to_meet_min_paid_for_the_week &&
          unable_to_meet_max_paid_for_the_week == o.unable_to_meet_max_paid_for_the_week &&
          no_need_days == o.no_need_days &&
          shifts_too_close_together == o.shifts_too_close_together
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [user_id, user_not_licensed, unable_to_meet_max_days, unable_to_schedule_required_days, unable_to_meet_min_paid_for_the_week, unable_to_meet_max_paid_for_the_week, no_need_days, shifts_too_close_together].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
