=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  # A complex type that defines service provider attributes or subattributes and their qualities.
  class ScimV2SchemaAttribute
    # The attribute's name
    attr_accessor :name

    # The data type of the attribute.
    attr_accessor :type

    # The list of subattributes for an attribute of the type \"complex\". Uses the same schema as \"attributes\".
    attr_accessor :sub_attributes

    # Indicates whether an attribute contains multiple values.
    attr_accessor :multi_valued

    # The description of the attribute.
    attr_accessor :description

    # Indicates whether an attribute is required.
    attr_accessor :required

    # The list of standard values that service providers may use. Service providers may ignore unsupported values.
    attr_accessor :canonical_values

    # Indicates whether a string attribute is case-sensitive. If set to \"true\", the server preserves case sensitivity. If set to \"false\", the server may change the case. The server also uses case sensitivity when evaluating filters. See section 3.4.2.2 \"Filtering\" in RFC 7644 for details.
    attr_accessor :case_exact

    # The circumstances under which an attribute can be defined or redefined. The default is \"readWrite\".
    attr_accessor :mutability

    # The circumstances under which an attribute and its values are returned in response to a GET, PUT, POST, or PATCH request.
    attr_accessor :returned

    # The method by which the service provider enforces the uniqueness of an attribute value. A server can reject a value by returning the HTTP response code 400 (Bad Request). A client can enforce uniqueness to a greater degree than the server provider enforces. For example, a client could make a value unique even though the server has \"uniqueness\" set to \"none\".
    attr_accessor :uniqueness

    # The list of SCIM resource types that may be referenced. Only applies when \"type\" is set to \"reference\".
    attr_accessor :reference_types

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'name' => :'name',
        
        :'type' => :'type',
        
        :'sub_attributes' => :'subAttributes',
        
        :'multi_valued' => :'multiValued',
        
        :'description' => :'description',
        
        :'required' => :'required',
        
        :'canonical_values' => :'canonicalValues',
        
        :'case_exact' => :'caseExact',
        
        :'mutability' => :'mutability',
        
        :'returned' => :'returned',
        
        :'uniqueness' => :'uniqueness',
        
        :'reference_types' => :'referenceTypes'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'name' => :'String',
        
        :'type' => :'String',
        
        :'sub_attributes' => :'Array<ScimV2SchemaAttribute>',
        
        :'multi_valued' => :'BOOLEAN',
        
        :'description' => :'String',
        
        :'required' => :'BOOLEAN',
        
        :'canonical_values' => :'Array<String>',
        
        :'case_exact' => :'BOOLEAN',
        
        :'mutability' => :'String',
        
        :'returned' => :'String',
        
        :'uniqueness' => :'String',
        
        :'reference_types' => :'Array<String>'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'type')
        
        
        self.type = attributes[:'type']
        
      
      end

      
      if attributes.has_key?(:'subAttributes')
        
        if (value = attributes[:'subAttributes']).is_a?(Array)
          self.sub_attributes = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'multiValued')
        
        
        self.multi_valued = attributes[:'multiValued']
        
      
      end

      
      if attributes.has_key?(:'description')
        
        
        self.description = attributes[:'description']
        
      
      end

      
      if attributes.has_key?(:'required')
        
        
        self.required = attributes[:'required']
        
      
      end

      
      if attributes.has_key?(:'canonicalValues')
        
        if (value = attributes[:'canonicalValues']).is_a?(Array)
          self.canonical_values = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'caseExact')
        
        
        self.case_exact = attributes[:'caseExact']
        
      
      end

      
      if attributes.has_key?(:'mutability')
        
        
        self.mutability = attributes[:'mutability']
        
      
      end

      
      if attributes.has_key?(:'returned')
        
        
        self.returned = attributes[:'returned']
        
      
      end

      
      if attributes.has_key?(:'uniqueness')
        
        
        self.uniqueness = attributes[:'uniqueness']
        
      
      end

      
      if attributes.has_key?(:'referenceTypes')
        
        if (value = attributes[:'referenceTypes']).is_a?(Array)
          self.reference_types = value
        end
        
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      allowed_values = ["STRING", "BOOLEAN", "DECIMAL", "INTEGER", "DATE_TIME", "REFERENCE", "COMPLEX"]
      if @type && !allowed_values.include?(@type)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["readWrite", "readOnly", "immutable", "writeOnly"]
      if @mutability && !allowed_values.include?(@mutability)
        return false
      end
      
      
      
      
      
      allowed_values = ["ALWAYS", "NEVER", "DEFAULT", "REQUEST"]
      if @returned && !allowed_values.include?(@returned)
        return false
      end
      
      
      
      
      
      allowed_values = ["NONE", "SERVER", "GLOBAL"]
      if @uniqueness && !allowed_values.include?(@uniqueness)
        return false
      end
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] type Object to be assigned
    def type=(type)
      allowed_values = ["STRING", "BOOLEAN", "DECIMAL", "INTEGER", "DATE_TIME", "REFERENCE", "COMPLEX"]
      if type && !allowed_values.include?(type)
        fail ArgumentError, "invalid value for 'type', must be one of #{allowed_values}."
      end
      @type = type
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] mutability Object to be assigned
    def mutability=(mutability)
      allowed_values = ["readWrite", "readOnly", "immutable", "writeOnly"]
      if mutability && !allowed_values.include?(mutability)
        fail ArgumentError, "invalid value for 'mutability', must be one of #{allowed_values}."
      end
      @mutability = mutability
    end

    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] returned Object to be assigned
    def returned=(returned)
      allowed_values = ["ALWAYS", "NEVER", "DEFAULT", "REQUEST"]
      if returned && !allowed_values.include?(returned)
        fail ArgumentError, "invalid value for 'returned', must be one of #{allowed_values}."
      end
      @returned = returned
    end

    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] uniqueness Object to be assigned
    def uniqueness=(uniqueness)
      allowed_values = ["NONE", "SERVER", "GLOBAL"]
      if uniqueness && !allowed_values.include?(uniqueness)
        fail ArgumentError, "invalid value for 'uniqueness', must be one of #{allowed_values}."
      end
      @uniqueness = uniqueness
    end

    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          type == o.type &&
          sub_attributes == o.sub_attributes &&
          multi_valued == o.multi_valued &&
          description == o.description &&
          required == o.required &&
          canonical_values == o.canonical_values &&
          case_exact == o.case_exact &&
          mutability == o.mutability &&
          returned == o.returned &&
          uniqueness == o.uniqueness &&
          reference_types == o.reference_types
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [name, type, sub_attributes, multi_valued, description, required, canonical_values, case_exact, mutability, returned, uniqueness, reference_types].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
