=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class ShiftTradeNotification
    # The start date of the schedule with which this trade is associated
    attr_accessor :week_date

    # The ID of the shift trade
    attr_accessor :trade_id

    # Whether this is a one sided shift trade
    attr_accessor :one_sided

    # The new state of the shift trade, null if there was no change
    attr_accessor :new_state

    # The user who initiated the shift trade
    attr_accessor :initiating_user

    # The start date and time of the initiating shift. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :initiating_shift_date

    # The user on the receiving side of this shift trade (null if not matched)
    attr_accessor :receiving_user

    # The start date and time of the receiving shift (null if not matched or if one-sided. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :receiving_shift_date

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'week_date' => :'weekDate',
        
        :'trade_id' => :'tradeId',
        
        :'one_sided' => :'oneSided',
        
        :'new_state' => :'newState',
        
        :'initiating_user' => :'initiatingUser',
        
        :'initiating_shift_date' => :'initiatingShiftDate',
        
        :'receiving_user' => :'receivingUser',
        
        :'receiving_shift_date' => :'receivingShiftDate'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'week_date' => :'String',
        
        :'trade_id' => :'String',
        
        :'one_sided' => :'BOOLEAN',
        
        :'new_state' => :'String',
        
        :'initiating_user' => :'UserReference',
        
        :'initiating_shift_date' => :'DateTime',
        
        :'receiving_user' => :'UserReference',
        
        :'receiving_shift_date' => :'DateTime'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'weekDate')
        
        
        self.week_date = attributes[:'weekDate']
        
      
      end

      
      if attributes.has_key?(:'tradeId')
        
        
        self.trade_id = attributes[:'tradeId']
        
      
      end

      
      if attributes.has_key?(:'oneSided')
        
        
        self.one_sided = attributes[:'oneSided']
        
      
      end

      
      if attributes.has_key?(:'newState')
        
        
        self.new_state = attributes[:'newState']
        
      
      end

      
      if attributes.has_key?(:'initiatingUser')
        
        
        self.initiating_user = attributes[:'initiatingUser']
        
      
      end

      
      if attributes.has_key?(:'initiatingShiftDate')
        
        
        self.initiating_shift_date = attributes[:'initiatingShiftDate']
        
      
      end

      
      if attributes.has_key?(:'receivingUser')
        
        
        self.receiving_user = attributes[:'receivingUser']
        
      
      end

      
      if attributes.has_key?(:'receivingShiftDate')
        
        
        self.receiving_shift_date = attributes[:'receivingShiftDate']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["Unmatched", "Matched", "Approved", "Denied", "Expired", "Canceled"]
      if @new_state && !allowed_values.include?(@new_state)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] new_state Object to be assigned
    def new_state=(new_state)
      allowed_values = ["Unmatched", "Matched", "Approved", "Denied", "Expired", "Canceled"]
      if new_state && !allowed_values.include?(new_state)
        fail ArgumentError, "invalid value for 'new_state', must be one of #{allowed_values}."
      end
      @new_state = new_state
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          week_date == o.week_date &&
          trade_id == o.trade_id &&
          one_sided == o.one_sided &&
          new_state == o.new_state &&
          initiating_user == o.initiating_user &&
          initiating_shift_date == o.initiating_shift_date &&
          receiving_user == o.receiving_user &&
          receiving_shift_date == o.receiving_shift_date
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [week_date, trade_id, one_sided, new_state, initiating_user, initiating_shift_date, receiving_user, receiving_shift_date].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
