=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class SmsPhoneNumber
    # The globally unique identifier for the object.
    attr_accessor :id

    attr_accessor :name

    # A phone number provisioned for SMS communications in E.164 format. E.g. +13175555555 or +34234234234
    attr_accessor :phone_number

    # Type of the phone number provisioned.
    attr_accessor :phone_number_type

    # Is set to false, if the phone number is provisioned through a SMS provider, outside of PureCloud
    attr_accessor :provisioned_through_pure_cloud

    # Status of the provisioned phone number.
    attr_accessor :phone_number_status

    # The capabilities of the phone number available for provisioning.
    attr_accessor :capabilities

    # The ISO 3166-1 alpha-2 country code of the country this phone number is associated with.
    attr_accessor :country_code

    # Date this phone number was provisioned. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_created

    # Date this phone number was modified. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_modified

    # User that provisioned this phone number
    attr_accessor :created_by

    # User that last modified this phone number
    attr_accessor :modified_by

    # Version number required for updates.
    attr_accessor :version

    # Date this phone number was purchased, if the phoneNumberType is shortcode. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :purchase_date

    # Contract end date of this phone number, if the phoneNumberType is shortcode. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :cancellation_date

    # Contract renewal date of this phone number, if the phoneNumberType is shortcode. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :renewal_date

    # Renewal time period of this phone number, if the phoneNumberType is shortcode.
    attr_accessor :auto_renewable

    # The id of an address attached to this phone number.
    attr_accessor :address_id

    # BillingType of this phone number, if the phoneNumberType is shortcode.
    attr_accessor :short_code_billing_type

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'phone_number' => :'phoneNumber',
        
        :'phone_number_type' => :'phoneNumberType',
        
        :'provisioned_through_pure_cloud' => :'provisionedThroughPureCloud',
        
        :'phone_number_status' => :'phoneNumberStatus',
        
        :'capabilities' => :'capabilities',
        
        :'country_code' => :'countryCode',
        
        :'date_created' => :'dateCreated',
        
        :'date_modified' => :'dateModified',
        
        :'created_by' => :'createdBy',
        
        :'modified_by' => :'modifiedBy',
        
        :'version' => :'version',
        
        :'purchase_date' => :'purchaseDate',
        
        :'cancellation_date' => :'cancellationDate',
        
        :'renewal_date' => :'renewalDate',
        
        :'auto_renewable' => :'autoRenewable',
        
        :'address_id' => :'addressId',
        
        :'short_code_billing_type' => :'shortCodeBillingType',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'id' => :'String',
        
        :'name' => :'String',
        
        :'phone_number' => :'String',
        
        :'phone_number_type' => :'String',
        
        :'provisioned_through_pure_cloud' => :'BOOLEAN',
        
        :'phone_number_status' => :'String',
        
        :'capabilities' => :'Array<String>',
        
        :'country_code' => :'String',
        
        :'date_created' => :'DateTime',
        
        :'date_modified' => :'DateTime',
        
        :'created_by' => :'User',
        
        :'modified_by' => :'User',
        
        :'version' => :'Integer',
        
        :'purchase_date' => :'DateTime',
        
        :'cancellation_date' => :'DateTime',
        
        :'renewal_date' => :'DateTime',
        
        :'auto_renewable' => :'String',
        
        :'address_id' => :'SmsAddress',
        
        :'short_code_billing_type' => :'String',
        
        :'self_uri' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'phoneNumber')
        
        
        self.phone_number = attributes[:'phoneNumber']
        
      
      end

      
      if attributes.has_key?(:'phoneNumberType')
        
        
        self.phone_number_type = attributes[:'phoneNumberType']
        
      
      end

      
      if attributes.has_key?(:'provisionedThroughPureCloud')
        
        
        self.provisioned_through_pure_cloud = attributes[:'provisionedThroughPureCloud']
        
      
      end

      
      if attributes.has_key?(:'phoneNumberStatus')
        
        
        self.phone_number_status = attributes[:'phoneNumberStatus']
        
      
      end

      
      if attributes.has_key?(:'capabilities')
        
        if (value = attributes[:'capabilities']).is_a?(Array)
          self.capabilities = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'countryCode')
        
        
        self.country_code = attributes[:'countryCode']
        
      
      end

      
      if attributes.has_key?(:'dateCreated')
        
        
        self.date_created = attributes[:'dateCreated']
        
      
      end

      
      if attributes.has_key?(:'dateModified')
        
        
        self.date_modified = attributes[:'dateModified']
        
      
      end

      
      if attributes.has_key?(:'createdBy')
        
        
        self.created_by = attributes[:'createdBy']
        
      
      end

      
      if attributes.has_key?(:'modifiedBy')
        
        
        self.modified_by = attributes[:'modifiedBy']
        
      
      end

      
      if attributes.has_key?(:'version')
        
        
        self.version = attributes[:'version']
        
      
      end

      
      if attributes.has_key?(:'purchaseDate')
        
        
        self.purchase_date = attributes[:'purchaseDate']
        
      
      end

      
      if attributes.has_key?(:'cancellationDate')
        
        
        self.cancellation_date = attributes[:'cancellationDate']
        
      
      end

      
      if attributes.has_key?(:'renewalDate')
        
        
        self.renewal_date = attributes[:'renewalDate']
        
      
      end

      
      if attributes.has_key?(:'autoRenewable')
        
        
        self.auto_renewable = attributes[:'autoRenewable']
        
      
      end

      
      if attributes.has_key?(:'addressId')
        
        
        self.address_id = attributes[:'addressId']
        
      
      end

      
      if attributes.has_key?(:'shortCodeBillingType')
        
        
        self.short_code_billing_type = attributes[:'shortCodeBillingType']
        
      
      end

      
      if attributes.has_key?(:'selfUri')
        
        
        self.self_uri = attributes[:'selfUri']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      if @phone_number.nil?
        return false
      end

      
      
      
      
      
      
      allowed_values = ["local", "mobile", "tollfree", "shortcode"]
      if @phone_number_type && !allowed_values.include?(@phone_number_type)
        return false
      end
      
      
      
      
      
      
      
      
      
      allowed_values = ["INVALID", "ACTIVE", "PORTING", "PENDING", "PENDING_CANCELLATION"]
      if @phone_number_status && !allowed_values.include?(@phone_number_status)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      if @version.nil?
        return false
      end

      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["Quarterly"]
      if @auto_renewable && !allowed_values.include?(@auto_renewable)
        return false
      end
      
      
      
      
      
      
      
      
      
      allowed_values = ["Basic", "Vanity"]
      if @short_code_billing_type && !allowed_values.include?(@short_code_billing_type)
        return false
      end
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] phone_number_type Object to be assigned
    def phone_number_type=(phone_number_type)
      allowed_values = ["local", "mobile", "tollfree", "shortcode"]
      if phone_number_type && !allowed_values.include?(phone_number_type)
        fail ArgumentError, "invalid value for 'phone_number_type', must be one of #{allowed_values}."
      end
      @phone_number_type = phone_number_type
    end

    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] phone_number_status Object to be assigned
    def phone_number_status=(phone_number_status)
      allowed_values = ["INVALID", "ACTIVE", "PORTING", "PENDING", "PENDING_CANCELLATION"]
      if phone_number_status && !allowed_values.include?(phone_number_status)
        fail ArgumentError, "invalid value for 'phone_number_status', must be one of #{allowed_values}."
      end
      @phone_number_status = phone_number_status
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] auto_renewable Object to be assigned
    def auto_renewable=(auto_renewable)
      allowed_values = ["Quarterly"]
      if auto_renewable && !allowed_values.include?(auto_renewable)
        fail ArgumentError, "invalid value for 'auto_renewable', must be one of #{allowed_values}."
      end
      @auto_renewable = auto_renewable
    end

    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] short_code_billing_type Object to be assigned
    def short_code_billing_type=(short_code_billing_type)
      allowed_values = ["Basic", "Vanity"]
      if short_code_billing_type && !allowed_values.include?(short_code_billing_type)
        fail ArgumentError, "invalid value for 'short_code_billing_type', must be one of #{allowed_values}."
      end
      @short_code_billing_type = short_code_billing_type
    end

    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          phone_number == o.phone_number &&
          phone_number_type == o.phone_number_type &&
          provisioned_through_pure_cloud == o.provisioned_through_pure_cloud &&
          phone_number_status == o.phone_number_status &&
          capabilities == o.capabilities &&
          country_code == o.country_code &&
          date_created == o.date_created &&
          date_modified == o.date_modified &&
          created_by == o.created_by &&
          modified_by == o.modified_by &&
          version == o.version &&
          purchase_date == o.purchase_date &&
          cancellation_date == o.cancellation_date &&
          renewal_date == o.renewal_date &&
          auto_renewable == o.auto_renewable &&
          address_id == o.address_id &&
          short_code_billing_type == o.short_code_billing_type &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, phone_number, phone_number_type, provisioned_through_pure_cloud, phone_number_status, capabilities, country_code, date_created, date_modified, created_by, modified_by, version, purchase_date, cancellation_date, renewal_date, auto_renewable, address_id, short_code_billing_type, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
