=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class TimeZoneMappingPreview
    # The associated ContactList
    attr_accessor :contact_list

    # The number of contacts per time zone that mapped to only that time zone
    attr_accessor :contacts_per_time_zone

    # The number of contacts per time zone that mapped to only that time zone and were mapped using the zip code column
    attr_accessor :contacts_mapped_using_zip_code

    # The total number of contacts that mapped to a single time zone
    attr_accessor :contacts_mapped_to_a_single_zone

    # The total number of contacts that mapped to a single time zone and were mapped using the zip code column
    attr_accessor :contacts_mapped_to_a_single_zone_using_zip_code

    # The total number of contacts that mapped to multiple time zones
    attr_accessor :contacts_mapped_to_multiple_zones

    # The total number of contacts that mapped to multiple time zones and were mapped using the zip code column
    attr_accessor :contacts_mapped_to_multiple_zones_using_zip_code

    # The total number of contacts that will be dialed during the default window
    attr_accessor :contacts_in_default_window

    # The total number of contacts in the contact list
    attr_accessor :contact_list_size

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'contact_list' => :'contactList',
        
        :'contacts_per_time_zone' => :'contactsPerTimeZone',
        
        :'contacts_mapped_using_zip_code' => :'contactsMappedUsingZipCode',
        
        :'contacts_mapped_to_a_single_zone' => :'contactsMappedToASingleZone',
        
        :'contacts_mapped_to_a_single_zone_using_zip_code' => :'contactsMappedToASingleZoneUsingZipCode',
        
        :'contacts_mapped_to_multiple_zones' => :'contactsMappedToMultipleZones',
        
        :'contacts_mapped_to_multiple_zones_using_zip_code' => :'contactsMappedToMultipleZonesUsingZipCode',
        
        :'contacts_in_default_window' => :'contactsInDefaultWindow',
        
        :'contact_list_size' => :'contactListSize'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'contact_list' => :'DomainEntityRef',
        
        :'contacts_per_time_zone' => :'Hash<String, Integer>',
        
        :'contacts_mapped_using_zip_code' => :'Hash<String, Integer>',
        
        :'contacts_mapped_to_a_single_zone' => :'Integer',
        
        :'contacts_mapped_to_a_single_zone_using_zip_code' => :'Integer',
        
        :'contacts_mapped_to_multiple_zones' => :'Integer',
        
        :'contacts_mapped_to_multiple_zones_using_zip_code' => :'Integer',
        
        :'contacts_in_default_window' => :'Integer',
        
        :'contact_list_size' => :'Integer'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'contactList')
        
        
        self.contact_list = attributes[:'contactList']
        
      
      end

      
      if attributes.has_key?(:'contactsPerTimeZone')
        
        if (value = attributes[:'contactsPerTimeZone']).is_a?(Array)
          self.contacts_per_time_zone = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'contactsMappedUsingZipCode')
        
        if (value = attributes[:'contactsMappedUsingZipCode']).is_a?(Array)
          self.contacts_mapped_using_zip_code = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'contactsMappedToASingleZone')
        
        
        self.contacts_mapped_to_a_single_zone = attributes[:'contactsMappedToASingleZone']
        
      
      end

      
      if attributes.has_key?(:'contactsMappedToASingleZoneUsingZipCode')
        
        
        self.contacts_mapped_to_a_single_zone_using_zip_code = attributes[:'contactsMappedToASingleZoneUsingZipCode']
        
      
      end

      
      if attributes.has_key?(:'contactsMappedToMultipleZones')
        
        
        self.contacts_mapped_to_multiple_zones = attributes[:'contactsMappedToMultipleZones']
        
      
      end

      
      if attributes.has_key?(:'contactsMappedToMultipleZonesUsingZipCode')
        
        
        self.contacts_mapped_to_multiple_zones_using_zip_code = attributes[:'contactsMappedToMultipleZonesUsingZipCode']
        
      
      end

      
      if attributes.has_key?(:'contactsInDefaultWindow')
        
        
        self.contacts_in_default_window = attributes[:'contactsInDefaultWindow']
        
      
      end

      
      if attributes.has_key?(:'contactListSize')
        
        
        self.contact_list_size = attributes[:'contactListSize']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          contact_list == o.contact_list &&
          contacts_per_time_zone == o.contacts_per_time_zone &&
          contacts_mapped_using_zip_code == o.contacts_mapped_using_zip_code &&
          contacts_mapped_to_a_single_zone == o.contacts_mapped_to_a_single_zone &&
          contacts_mapped_to_a_single_zone_using_zip_code == o.contacts_mapped_to_a_single_zone_using_zip_code &&
          contacts_mapped_to_multiple_zones == o.contacts_mapped_to_multiple_zones &&
          contacts_mapped_to_multiple_zones_using_zip_code == o.contacts_mapped_to_multiple_zones_using_zip_code &&
          contacts_in_default_window == o.contacts_in_default_window &&
          contact_list_size == o.contact_list_size
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [contact_list, contacts_per_time_zone, contacts_mapped_using_zip_code, contacts_mapped_to_a_single_zone, contacts_mapped_to_a_single_zone_using_zip_code, contacts_mapped_to_multiple_zones, contacts_mapped_to_multiple_zones_using_zip_code, contacts_in_default_window, contact_list_size].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
