=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class UserQueue
    # The globally unique identifier for the object.
    attr_accessor :id

    attr_accessor :name

    # The division to which this entity belongs.
    attr_accessor :division

    # The queue description.
    attr_accessor :description

    # The date the queue was created. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_created

    # The date of the last modification to the queue. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ
    attr_accessor :date_modified

    # The ID of the user that last modified the queue.
    attr_accessor :modified_by

    # The ID of the user that created the queue.
    attr_accessor :created_by

    # The number of users in the queue.
    attr_accessor :member_count

    # The media settings for the queue. Valid key values: CALL, CALLBACK, CHAT, EMAIL, MESSAGE, SOCIAL_EXPRESSION, VIDEO_COMM
    attr_accessor :media_settings

    # The routing rules for the queue, used for routing to known or preferred agents.
    attr_accessor :routing_rules

    # The bulls-eye settings for the queue.
    attr_accessor :bullseye

    # The ACW settings for the queue.
    attr_accessor :acw_settings

    # The skill evaluation method to use when routing conversations.
    attr_accessor :skill_evaluation_method

    # The in-queue flow to use for conversations waiting in queue.
    attr_accessor :queue_flow

    # The prompt used for whisper on the queue, if configured.
    attr_accessor :whisper_prompt

    # Indicates whether voice transcription is enabled for this queue.
    attr_accessor :enable_transcription

    # Indicates whether manual assignment is enabled for this queue.
    attr_accessor :enable_manual_assignment

    # The name to use for caller identification for outbound calls from this queue.
    attr_accessor :calling_party_name

    # The phone number to use for caller identification for outbound calls from this queue.
    attr_accessor :calling_party_number

    # The default script Ids for the communication types.
    attr_accessor :default_scripts

    # The messaging addresses for the queue.
    attr_accessor :outbound_messaging_addresses

    attr_accessor :outbound_email_address

    attr_accessor :joined

    # The URI for this object
    attr_accessor :self_uri

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'id' => :'id',
        
        :'name' => :'name',
        
        :'division' => :'division',
        
        :'description' => :'description',
        
        :'date_created' => :'dateCreated',
        
        :'date_modified' => :'dateModified',
        
        :'modified_by' => :'modifiedBy',
        
        :'created_by' => :'createdBy',
        
        :'member_count' => :'memberCount',
        
        :'media_settings' => :'mediaSettings',
        
        :'routing_rules' => :'routingRules',
        
        :'bullseye' => :'bullseye',
        
        :'acw_settings' => :'acwSettings',
        
        :'skill_evaluation_method' => :'skillEvaluationMethod',
        
        :'queue_flow' => :'queueFlow',
        
        :'whisper_prompt' => :'whisperPrompt',
        
        :'enable_transcription' => :'enableTranscription',
        
        :'enable_manual_assignment' => :'enableManualAssignment',
        
        :'calling_party_name' => :'callingPartyName',
        
        :'calling_party_number' => :'callingPartyNumber',
        
        :'default_scripts' => :'defaultScripts',
        
        :'outbound_messaging_addresses' => :'outboundMessagingAddresses',
        
        :'outbound_email_address' => :'outboundEmailAddress',
        
        :'joined' => :'joined',
        
        :'self_uri' => :'selfUri'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'id' => :'String',
        
        :'name' => :'String',
        
        :'division' => :'Division',
        
        :'description' => :'String',
        
        :'date_created' => :'DateTime',
        
        :'date_modified' => :'DateTime',
        
        :'modified_by' => :'String',
        
        :'created_by' => :'String',
        
        :'member_count' => :'Integer',
        
        :'media_settings' => :'Hash<String, MediaSetting>',
        
        :'routing_rules' => :'Array<RoutingRule>',
        
        :'bullseye' => :'Bullseye',
        
        :'acw_settings' => :'AcwSettings',
        
        :'skill_evaluation_method' => :'String',
        
        :'queue_flow' => :'DomainEntityRef',
        
        :'whisper_prompt' => :'DomainEntityRef',
        
        :'enable_transcription' => :'BOOLEAN',
        
        :'enable_manual_assignment' => :'BOOLEAN',
        
        :'calling_party_name' => :'String',
        
        :'calling_party_number' => :'String',
        
        :'default_scripts' => :'Hash<String, Script>',
        
        :'outbound_messaging_addresses' => :'QueueMessagingAddresses',
        
        :'outbound_email_address' => :'QueueEmailAddress',
        
        :'joined' => :'BOOLEAN',
        
        :'self_uri' => :'String'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'name')
        
        
        self.name = attributes[:'name']
        
      
      end

      
      if attributes.has_key?(:'division')
        
        
        self.division = attributes[:'division']
        
      
      end

      
      if attributes.has_key?(:'description')
        
        
        self.description = attributes[:'description']
        
      
      end

      
      if attributes.has_key?(:'dateCreated')
        
        
        self.date_created = attributes[:'dateCreated']
        
      
      end

      
      if attributes.has_key?(:'dateModified')
        
        
        self.date_modified = attributes[:'dateModified']
        
      
      end

      
      if attributes.has_key?(:'modifiedBy')
        
        
        self.modified_by = attributes[:'modifiedBy']
        
      
      end

      
      if attributes.has_key?(:'createdBy')
        
        
        self.created_by = attributes[:'createdBy']
        
      
      end

      
      if attributes.has_key?(:'memberCount')
        
        
        self.member_count = attributes[:'memberCount']
        
      
      end

      
      if attributes.has_key?(:'mediaSettings')
        
        if (value = attributes[:'mediaSettings']).is_a?(Array)
          self.media_settings = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'routingRules')
        
        if (value = attributes[:'routingRules']).is_a?(Array)
          self.routing_rules = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'bullseye')
        
        
        self.bullseye = attributes[:'bullseye']
        
      
      end

      
      if attributes.has_key?(:'acwSettings')
        
        
        self.acw_settings = attributes[:'acwSettings']
        
      
      end

      
      if attributes.has_key?(:'skillEvaluationMethod')
        
        
        self.skill_evaluation_method = attributes[:'skillEvaluationMethod']
        
      
      end

      
      if attributes.has_key?(:'queueFlow')
        
        
        self.queue_flow = attributes[:'queueFlow']
        
      
      end

      
      if attributes.has_key?(:'whisperPrompt')
        
        
        self.whisper_prompt = attributes[:'whisperPrompt']
        
      
      end

      
      if attributes.has_key?(:'enableTranscription')
        
        
        self.enable_transcription = attributes[:'enableTranscription']
        
      
      end

      
      if attributes.has_key?(:'enableManualAssignment')
        
        
        self.enable_manual_assignment = attributes[:'enableManualAssignment']
        
      
      end

      
      if attributes.has_key?(:'callingPartyName')
        
        
        self.calling_party_name = attributes[:'callingPartyName']
        
      
      end

      
      if attributes.has_key?(:'callingPartyNumber')
        
        
        self.calling_party_number = attributes[:'callingPartyNumber']
        
      
      end

      
      if attributes.has_key?(:'defaultScripts')
        
        if (value = attributes[:'defaultScripts']).is_a?(Array)
          self.default_scripts = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'outboundMessagingAddresses')
        
        
        self.outbound_messaging_addresses = attributes[:'outboundMessagingAddresses']
        
      
      end

      
      if attributes.has_key?(:'outboundEmailAddress')
        
        
        self.outbound_email_address = attributes[:'outboundEmailAddress']
        
      
      end

      
      if attributes.has_key?(:'joined')
        
        
        self.joined = attributes[:'joined']
        
      
      end

      
      if attributes.has_key?(:'selfUri')
        
        
        self.self_uri = attributes[:'selfUri']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      allowed_values = ["NONE", "BEST", "ALL"]
      if @skill_evaluation_method && !allowed_values.include?(@skill_evaluation_method)
        return false
      end
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] skill_evaluation_method Object to be assigned
    def skill_evaluation_method=(skill_evaluation_method)
      allowed_values = ["NONE", "BEST", "ALL"]
      if skill_evaluation_method && !allowed_values.include?(skill_evaluation_method)
        fail ArgumentError, "invalid value for 'skill_evaluation_method', must be one of #{allowed_values}."
      end
      @skill_evaluation_method = skill_evaluation_method
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          division == o.division &&
          description == o.description &&
          date_created == o.date_created &&
          date_modified == o.date_modified &&
          modified_by == o.modified_by &&
          created_by == o.created_by &&
          member_count == o.member_count &&
          media_settings == o.media_settings &&
          routing_rules == o.routing_rules &&
          bullseye == o.bullseye &&
          acw_settings == o.acw_settings &&
          skill_evaluation_method == o.skill_evaluation_method &&
          queue_flow == o.queue_flow &&
          whisper_prompt == o.whisper_prompt &&
          enable_transcription == o.enable_transcription &&
          enable_manual_assignment == o.enable_manual_assignment &&
          calling_party_name == o.calling_party_name &&
          calling_party_number == o.calling_party_number &&
          default_scripts == o.default_scripts &&
          outbound_messaging_addresses == o.outbound_messaging_addresses &&
          outbound_email_address == o.outbound_email_address &&
          joined == o.joined &&
          self_uri == o.self_uri
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, division, description, date_created, date_modified, modified_by, created_by, member_count, media_settings, routing_rules, bullseye, acw_settings, skill_evaluation_method, queue_flow, whisper_prompt, enable_transcription, enable_manual_assignment, calling_party_name, calling_party_number, default_scripts, outbound_messaging_addresses, outbound_email_address, joined, self_uri].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
