=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  class ViewFilter
    # The media types are used to filter the view
    attr_accessor :media_types

    # The queue ids are used to filter the view
    attr_accessor :queue_ids

    # The skill ids are used to filter the view
    attr_accessor :skill_ids

    # The skill groups used to filter the view
    attr_accessor :skill_groups

    # The language ids are used to filter the view
    attr_accessor :language_ids

    # The language groups used to filter the view
    attr_accessor :language_groups

    # The directions are used to filter the view
    attr_accessor :directions

    # The list of orginating directions used to filter the view
    attr_accessor :originating_directions

    # The wrap up codes are used to filter the view
    attr_accessor :wrap_up_codes

    # The dnis list is used to filter the view
    attr_accessor :dnis_list

    # The list of session dnis used to filter the view
    attr_accessor :session_dnis_list

    # The user ids are used to fetch associated queues for the view
    attr_accessor :filter_queues_by_user_ids

    # The queue ids are used to fetch associated users for the view
    attr_accessor :filter_users_by_queue_ids

    # The user ids are used to filter the view
    attr_accessor :user_ids

    # The address To values are used to filter the view
    attr_accessor :address_tos

    # The address from values are used to filter the view
    attr_accessor :address_froms

    # The outbound campaign ids are used to filter the view
    attr_accessor :outbound_campaign_ids

    # The outbound contact list ids are used to filter the view
    attr_accessor :outbound_contact_list_ids

    # The contact ids are used to filter the view
    attr_accessor :contact_ids

    # The external contact ids are used to filter the view
    attr_accessor :external_contact_ids

    # The external org ids are used to filter the view
    attr_accessor :external_org_ids

    # The ani list ids are used to filter the view
    attr_accessor :ani_list

    # The durations in milliseconds used to filter the view
    attr_accessor :durations_milliseconds

    # The acd durations in milliseconds used to filter the view
    attr_accessor :acd_durations_milliseconds

    # The talk durations in milliseconds used to filter the view
    attr_accessor :talk_durations_milliseconds

    # The acw durations in milliseconds used to filter the view
    attr_accessor :acw_durations_milliseconds

    # The handle durations in milliseconds used to filter the view
    attr_accessor :handle_durations_milliseconds

    # The hold durations in milliseconds used to filter the view
    attr_accessor :hold_durations_milliseconds

    # The abandon durations in milliseconds used to filter the view
    attr_accessor :abandon_durations_milliseconds

    # The evaluationScore is used to filter the view
    attr_accessor :evaluation_score

    # The evaluationCriticalScore is used to filter the view
    attr_accessor :evaluation_critical_score

    # The evaluation form ids are used to filter the view
    attr_accessor :evaluation_form_ids

    # The evaluated agent ids are used to filter the view
    attr_accessor :evaluated_agent_ids

    # The evaluator ids are used to filter the view
    attr_accessor :evaluator_ids

    # Indicates filtering for transfers
    attr_accessor :transferred

    # Indicates filtering for abandons
    attr_accessor :abandoned

    # Indicates filtering for answered interactions
    attr_accessor :answered

    # The message media types used to filter the view
    attr_accessor :message_types

    # The divison Ids used to filter the view
    attr_accessor :division_ids

    # The survey form ids used to filter the view
    attr_accessor :survey_form_ids

    # The survey total score used to filter the view
    attr_accessor :survey_total_score

    # The survey NPS score used to filter the view
    attr_accessor :survey_nps_score

    # The desired range for mos values
    attr_accessor :mos

    # The survey question group score used to filter the view
    attr_accessor :survey_question_group_score

    # The survey promoter score used to filter the view
    attr_accessor :survey_promoter_score

    # The list of survey form context ids used to filter the view
    attr_accessor :survey_form_context_ids

    # The list of conversation ids used to filter the view
    attr_accessor :conversation_ids

    # The list of SIP call ids used to filter the view
    attr_accessor :sip_call_ids

    # Indicates filtering for ended
    attr_accessor :is_ended

    # Indicates filtering for survey
    attr_accessor :is_surveyed

    # The list of survey score ranges used to filter the view
    attr_accessor :survey_scores

    # The list of promoter score ranges used to filter the view
    attr_accessor :promoter_scores

    # Indicates filtering for campaign
    attr_accessor :is_campaign

    # The list of survey statuses used to filter the view
    attr_accessor :survey_statuses

    # A grouping of conversation level filters
    attr_accessor :conversation_properties

    # Indicates filtering for blind transferred
    attr_accessor :is_blind_transferred

    # Indicates filtering for consulted
    attr_accessor :is_consulted

    # Indicates filtering for consult transferred
    attr_accessor :is_consult_transferred

    # The list of remote participants used to filter the view
    attr_accessor :remote_participants

    # The list of flow Ids
    attr_accessor :flow_ids

    # A list of outcome ids of the flow
    attr_accessor :flow_outcome_ids

    # A list of outcome values of the flow
    attr_accessor :flow_outcome_values

    # The list of destination types of the flow
    attr_accessor :flow_destination_types

    # The list of reasons for the flow to disconnect
    attr_accessor :flow_disconnect_reasons

    # A list of types of the flow
    attr_accessor :flow_types

    # A list of types of the flow entry
    attr_accessor :flow_entry_types

    # A list of reasons of flow entry
    attr_accessor :flow_entry_reasons

    # A list of versions of a flow
    attr_accessor :flow_versions

    # A list of directory group ids
    attr_accessor :group_ids

    # Indicates filtering for journey customer id
    attr_accessor :has_journey_customer_id

    # Indicates filtering for Journey action map id
    attr_accessor :has_journey_action_map_id

    # Indicates filtering for Journey visit id
    attr_accessor :has_journey_visit_id

    # Indicates filtering for presence of MMS media
    attr_accessor :has_media

    # The role Ids used to filter the view
    attr_accessor :role_ids

    # The report to user IDs used to filter the view
    attr_accessor :reports_tos

    # The location Ids used to filter the view
    attr_accessor :location_ids

    # A list of flow out types
    attr_accessor :flow_out_types

    # A list of providers
    attr_accessor :provider_list

    # A list of callback numbers or substrings of numbers (ex: [\"317\", \"13172222222\"])
    attr_accessor :callback_number_list

    # An interval of time to filter for scheduled callbacks. Intervals are represented as an ISO-8601 string. For example: YYYY-MM-DDThh:mm:ss/YYYY-MM-DDThh:mm:ss
    attr_accessor :callback_interval

    # A list of routing types used
    attr_accessor :used_routing_types

    # A list of routing types requested
    attr_accessor :requested_routing_types

    # Indicates filtering for agent assist id
    attr_accessor :has_agent_assist_id

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'media_types' => :'mediaTypes',
        
        :'queue_ids' => :'queueIds',
        
        :'skill_ids' => :'skillIds',
        
        :'skill_groups' => :'skillGroups',
        
        :'language_ids' => :'languageIds',
        
        :'language_groups' => :'languageGroups',
        
        :'directions' => :'directions',
        
        :'originating_directions' => :'originatingDirections',
        
        :'wrap_up_codes' => :'wrapUpCodes',
        
        :'dnis_list' => :'dnisList',
        
        :'session_dnis_list' => :'sessionDnisList',
        
        :'filter_queues_by_user_ids' => :'filterQueuesByUserIds',
        
        :'filter_users_by_queue_ids' => :'filterUsersByQueueIds',
        
        :'user_ids' => :'userIds',
        
        :'address_tos' => :'addressTos',
        
        :'address_froms' => :'addressFroms',
        
        :'outbound_campaign_ids' => :'outboundCampaignIds',
        
        :'outbound_contact_list_ids' => :'outboundContactListIds',
        
        :'contact_ids' => :'contactIds',
        
        :'external_contact_ids' => :'externalContactIds',
        
        :'external_org_ids' => :'externalOrgIds',
        
        :'ani_list' => :'aniList',
        
        :'durations_milliseconds' => :'durationsMilliseconds',
        
        :'acd_durations_milliseconds' => :'acdDurationsMilliseconds',
        
        :'talk_durations_milliseconds' => :'talkDurationsMilliseconds',
        
        :'acw_durations_milliseconds' => :'acwDurationsMilliseconds',
        
        :'handle_durations_milliseconds' => :'handleDurationsMilliseconds',
        
        :'hold_durations_milliseconds' => :'holdDurationsMilliseconds',
        
        :'abandon_durations_milliseconds' => :'abandonDurationsMilliseconds',
        
        :'evaluation_score' => :'evaluationScore',
        
        :'evaluation_critical_score' => :'evaluationCriticalScore',
        
        :'evaluation_form_ids' => :'evaluationFormIds',
        
        :'evaluated_agent_ids' => :'evaluatedAgentIds',
        
        :'evaluator_ids' => :'evaluatorIds',
        
        :'transferred' => :'transferred',
        
        :'abandoned' => :'abandoned',
        
        :'answered' => :'answered',
        
        :'message_types' => :'messageTypes',
        
        :'division_ids' => :'divisionIds',
        
        :'survey_form_ids' => :'surveyFormIds',
        
        :'survey_total_score' => :'surveyTotalScore',
        
        :'survey_nps_score' => :'surveyNpsScore',
        
        :'mos' => :'mos',
        
        :'survey_question_group_score' => :'surveyQuestionGroupScore',
        
        :'survey_promoter_score' => :'surveyPromoterScore',
        
        :'survey_form_context_ids' => :'surveyFormContextIds',
        
        :'conversation_ids' => :'conversationIds',
        
        :'sip_call_ids' => :'sipCallIds',
        
        :'is_ended' => :'isEnded',
        
        :'is_surveyed' => :'isSurveyed',
        
        :'survey_scores' => :'surveyScores',
        
        :'promoter_scores' => :'promoterScores',
        
        :'is_campaign' => :'isCampaign',
        
        :'survey_statuses' => :'surveyStatuses',
        
        :'conversation_properties' => :'conversationProperties',
        
        :'is_blind_transferred' => :'isBlindTransferred',
        
        :'is_consulted' => :'isConsulted',
        
        :'is_consult_transferred' => :'isConsultTransferred',
        
        :'remote_participants' => :'remoteParticipants',
        
        :'flow_ids' => :'flowIds',
        
        :'flow_outcome_ids' => :'flowOutcomeIds',
        
        :'flow_outcome_values' => :'flowOutcomeValues',
        
        :'flow_destination_types' => :'flowDestinationTypes',
        
        :'flow_disconnect_reasons' => :'flowDisconnectReasons',
        
        :'flow_types' => :'flowTypes',
        
        :'flow_entry_types' => :'flowEntryTypes',
        
        :'flow_entry_reasons' => :'flowEntryReasons',
        
        :'flow_versions' => :'flowVersions',
        
        :'group_ids' => :'groupIds',
        
        :'has_journey_customer_id' => :'hasJourneyCustomerId',
        
        :'has_journey_action_map_id' => :'hasJourneyActionMapId',
        
        :'has_journey_visit_id' => :'hasJourneyVisitId',
        
        :'has_media' => :'hasMedia',
        
        :'role_ids' => :'roleIds',
        
        :'reports_tos' => :'reportsTos',
        
        :'location_ids' => :'locationIds',
        
        :'flow_out_types' => :'flowOutTypes',
        
        :'provider_list' => :'providerList',
        
        :'callback_number_list' => :'callbackNumberList',
        
        :'callback_interval' => :'callbackInterval',
        
        :'used_routing_types' => :'usedRoutingTypes',
        
        :'requested_routing_types' => :'requestedRoutingTypes',
        
        :'has_agent_assist_id' => :'hasAgentAssistId'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'media_types' => :'Array<String>',
        
        :'queue_ids' => :'Array<String>',
        
        :'skill_ids' => :'Array<String>',
        
        :'skill_groups' => :'Array<String>',
        
        :'language_ids' => :'Array<String>',
        
        :'language_groups' => :'Array<String>',
        
        :'directions' => :'Array<String>',
        
        :'originating_directions' => :'Array<String>',
        
        :'wrap_up_codes' => :'Array<String>',
        
        :'dnis_list' => :'Array<String>',
        
        :'session_dnis_list' => :'Array<String>',
        
        :'filter_queues_by_user_ids' => :'Array<String>',
        
        :'filter_users_by_queue_ids' => :'Array<String>',
        
        :'user_ids' => :'Array<String>',
        
        :'address_tos' => :'Array<String>',
        
        :'address_froms' => :'Array<String>',
        
        :'outbound_campaign_ids' => :'Array<String>',
        
        :'outbound_contact_list_ids' => :'Array<String>',
        
        :'contact_ids' => :'Array<String>',
        
        :'external_contact_ids' => :'Array<String>',
        
        :'external_org_ids' => :'Array<String>',
        
        :'ani_list' => :'Array<String>',
        
        :'durations_milliseconds' => :'Array<NumericRange>',
        
        :'acd_durations_milliseconds' => :'Array<NumericRange>',
        
        :'talk_durations_milliseconds' => :'Array<NumericRange>',
        
        :'acw_durations_milliseconds' => :'Array<NumericRange>',
        
        :'handle_durations_milliseconds' => :'Array<NumericRange>',
        
        :'hold_durations_milliseconds' => :'Array<NumericRange>',
        
        :'abandon_durations_milliseconds' => :'Array<NumericRange>',
        
        :'evaluation_score' => :'NumericRange',
        
        :'evaluation_critical_score' => :'NumericRange',
        
        :'evaluation_form_ids' => :'Array<String>',
        
        :'evaluated_agent_ids' => :'Array<String>',
        
        :'evaluator_ids' => :'Array<String>',
        
        :'transferred' => :'BOOLEAN',
        
        :'abandoned' => :'BOOLEAN',
        
        :'answered' => :'BOOLEAN',
        
        :'message_types' => :'Array<String>',
        
        :'division_ids' => :'Array<String>',
        
        :'survey_form_ids' => :'Array<String>',
        
        :'survey_total_score' => :'NumericRange',
        
        :'survey_nps_score' => :'NumericRange',
        
        :'mos' => :'NumericRange',
        
        :'survey_question_group_score' => :'NumericRange',
        
        :'survey_promoter_score' => :'NumericRange',
        
        :'survey_form_context_ids' => :'Array<String>',
        
        :'conversation_ids' => :'Array<String>',
        
        :'sip_call_ids' => :'Array<String>',
        
        :'is_ended' => :'BOOLEAN',
        
        :'is_surveyed' => :'BOOLEAN',
        
        :'survey_scores' => :'Array<NumericRange>',
        
        :'promoter_scores' => :'Array<NumericRange>',
        
        :'is_campaign' => :'BOOLEAN',
        
        :'survey_statuses' => :'Array<String>',
        
        :'conversation_properties' => :'ConversationProperties',
        
        :'is_blind_transferred' => :'BOOLEAN',
        
        :'is_consulted' => :'BOOLEAN',
        
        :'is_consult_transferred' => :'BOOLEAN',
        
        :'remote_participants' => :'Array<String>',
        
        :'flow_ids' => :'Array<String>',
        
        :'flow_outcome_ids' => :'Array<String>',
        
        :'flow_outcome_values' => :'Array<String>',
        
        :'flow_destination_types' => :'Array<String>',
        
        :'flow_disconnect_reasons' => :'Array<String>',
        
        :'flow_types' => :'Array<String>',
        
        :'flow_entry_types' => :'Array<String>',
        
        :'flow_entry_reasons' => :'Array<String>',
        
        :'flow_versions' => :'Array<String>',
        
        :'group_ids' => :'Array<String>',
        
        :'has_journey_customer_id' => :'BOOLEAN',
        
        :'has_journey_action_map_id' => :'BOOLEAN',
        
        :'has_journey_visit_id' => :'BOOLEAN',
        
        :'has_media' => :'BOOLEAN',
        
        :'role_ids' => :'Array<String>',
        
        :'reports_tos' => :'Array<String>',
        
        :'location_ids' => :'Array<String>',
        
        :'flow_out_types' => :'Array<String>',
        
        :'provider_list' => :'Array<String>',
        
        :'callback_number_list' => :'Array<String>',
        
        :'callback_interval' => :'String',
        
        :'used_routing_types' => :'Array<String>',
        
        :'requested_routing_types' => :'Array<String>',
        
        :'has_agent_assist_id' => :'BOOLEAN'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'mediaTypes')
        
        if (value = attributes[:'mediaTypes']).is_a?(Array)
          self.media_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'queueIds')
        
        if (value = attributes[:'queueIds']).is_a?(Array)
          self.queue_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'skillIds')
        
        if (value = attributes[:'skillIds']).is_a?(Array)
          self.skill_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'skillGroups')
        
        if (value = attributes[:'skillGroups']).is_a?(Array)
          self.skill_groups = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'languageIds')
        
        if (value = attributes[:'languageIds']).is_a?(Array)
          self.language_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'languageGroups')
        
        if (value = attributes[:'languageGroups']).is_a?(Array)
          self.language_groups = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'directions')
        
        if (value = attributes[:'directions']).is_a?(Array)
          self.directions = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'originatingDirections')
        
        if (value = attributes[:'originatingDirections']).is_a?(Array)
          self.originating_directions = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'wrapUpCodes')
        
        if (value = attributes[:'wrapUpCodes']).is_a?(Array)
          self.wrap_up_codes = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'dnisList')
        
        if (value = attributes[:'dnisList']).is_a?(Array)
          self.dnis_list = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'sessionDnisList')
        
        if (value = attributes[:'sessionDnisList']).is_a?(Array)
          self.session_dnis_list = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'filterQueuesByUserIds')
        
        if (value = attributes[:'filterQueuesByUserIds']).is_a?(Array)
          self.filter_queues_by_user_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'filterUsersByQueueIds')
        
        if (value = attributes[:'filterUsersByQueueIds']).is_a?(Array)
          self.filter_users_by_queue_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'userIds')
        
        if (value = attributes[:'userIds']).is_a?(Array)
          self.user_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'addressTos')
        
        if (value = attributes[:'addressTos']).is_a?(Array)
          self.address_tos = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'addressFroms')
        
        if (value = attributes[:'addressFroms']).is_a?(Array)
          self.address_froms = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'outboundCampaignIds')
        
        if (value = attributes[:'outboundCampaignIds']).is_a?(Array)
          self.outbound_campaign_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'outboundContactListIds')
        
        if (value = attributes[:'outboundContactListIds']).is_a?(Array)
          self.outbound_contact_list_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'contactIds')
        
        if (value = attributes[:'contactIds']).is_a?(Array)
          self.contact_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'externalContactIds')
        
        if (value = attributes[:'externalContactIds']).is_a?(Array)
          self.external_contact_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'externalOrgIds')
        
        if (value = attributes[:'externalOrgIds']).is_a?(Array)
          self.external_org_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'aniList')
        
        if (value = attributes[:'aniList']).is_a?(Array)
          self.ani_list = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'durationsMilliseconds')
        
        if (value = attributes[:'durationsMilliseconds']).is_a?(Array)
          self.durations_milliseconds = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'acdDurationsMilliseconds')
        
        if (value = attributes[:'acdDurationsMilliseconds']).is_a?(Array)
          self.acd_durations_milliseconds = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'talkDurationsMilliseconds')
        
        if (value = attributes[:'talkDurationsMilliseconds']).is_a?(Array)
          self.talk_durations_milliseconds = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'acwDurationsMilliseconds')
        
        if (value = attributes[:'acwDurationsMilliseconds']).is_a?(Array)
          self.acw_durations_milliseconds = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'handleDurationsMilliseconds')
        
        if (value = attributes[:'handleDurationsMilliseconds']).is_a?(Array)
          self.handle_durations_milliseconds = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'holdDurationsMilliseconds')
        
        if (value = attributes[:'holdDurationsMilliseconds']).is_a?(Array)
          self.hold_durations_milliseconds = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'abandonDurationsMilliseconds')
        
        if (value = attributes[:'abandonDurationsMilliseconds']).is_a?(Array)
          self.abandon_durations_milliseconds = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'evaluationScore')
        
        
        self.evaluation_score = attributes[:'evaluationScore']
        
      
      end

      
      if attributes.has_key?(:'evaluationCriticalScore')
        
        
        self.evaluation_critical_score = attributes[:'evaluationCriticalScore']
        
      
      end

      
      if attributes.has_key?(:'evaluationFormIds')
        
        if (value = attributes[:'evaluationFormIds']).is_a?(Array)
          self.evaluation_form_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'evaluatedAgentIds')
        
        if (value = attributes[:'evaluatedAgentIds']).is_a?(Array)
          self.evaluated_agent_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'evaluatorIds')
        
        if (value = attributes[:'evaluatorIds']).is_a?(Array)
          self.evaluator_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'transferred')
        
        
        self.transferred = attributes[:'transferred']
        
      
      end

      
      if attributes.has_key?(:'abandoned')
        
        
        self.abandoned = attributes[:'abandoned']
        
      
      end

      
      if attributes.has_key?(:'answered')
        
        
        self.answered = attributes[:'answered']
        
      
      end

      
      if attributes.has_key?(:'messageTypes')
        
        if (value = attributes[:'messageTypes']).is_a?(Array)
          self.message_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'divisionIds')
        
        if (value = attributes[:'divisionIds']).is_a?(Array)
          self.division_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'surveyFormIds')
        
        if (value = attributes[:'surveyFormIds']).is_a?(Array)
          self.survey_form_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'surveyTotalScore')
        
        
        self.survey_total_score = attributes[:'surveyTotalScore']
        
      
      end

      
      if attributes.has_key?(:'surveyNpsScore')
        
        
        self.survey_nps_score = attributes[:'surveyNpsScore']
        
      
      end

      
      if attributes.has_key?(:'mos')
        
        
        self.mos = attributes[:'mos']
        
      
      end

      
      if attributes.has_key?(:'surveyQuestionGroupScore')
        
        
        self.survey_question_group_score = attributes[:'surveyQuestionGroupScore']
        
      
      end

      
      if attributes.has_key?(:'surveyPromoterScore')
        
        
        self.survey_promoter_score = attributes[:'surveyPromoterScore']
        
      
      end

      
      if attributes.has_key?(:'surveyFormContextIds')
        
        if (value = attributes[:'surveyFormContextIds']).is_a?(Array)
          self.survey_form_context_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'conversationIds')
        
        if (value = attributes[:'conversationIds']).is_a?(Array)
          self.conversation_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'sipCallIds')
        
        if (value = attributes[:'sipCallIds']).is_a?(Array)
          self.sip_call_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'isEnded')
        
        
        self.is_ended = attributes[:'isEnded']
        
      
      end

      
      if attributes.has_key?(:'isSurveyed')
        
        
        self.is_surveyed = attributes[:'isSurveyed']
        
      
      end

      
      if attributes.has_key?(:'surveyScores')
        
        if (value = attributes[:'surveyScores']).is_a?(Array)
          self.survey_scores = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'promoterScores')
        
        if (value = attributes[:'promoterScores']).is_a?(Array)
          self.promoter_scores = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'isCampaign')
        
        
        self.is_campaign = attributes[:'isCampaign']
        
      
      end

      
      if attributes.has_key?(:'surveyStatuses')
        
        if (value = attributes[:'surveyStatuses']).is_a?(Array)
          self.survey_statuses = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'conversationProperties')
        
        
        self.conversation_properties = attributes[:'conversationProperties']
        
      
      end

      
      if attributes.has_key?(:'isBlindTransferred')
        
        
        self.is_blind_transferred = attributes[:'isBlindTransferred']
        
      
      end

      
      if attributes.has_key?(:'isConsulted')
        
        
        self.is_consulted = attributes[:'isConsulted']
        
      
      end

      
      if attributes.has_key?(:'isConsultTransferred')
        
        
        self.is_consult_transferred = attributes[:'isConsultTransferred']
        
      
      end

      
      if attributes.has_key?(:'remoteParticipants')
        
        if (value = attributes[:'remoteParticipants']).is_a?(Array)
          self.remote_participants = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowIds')
        
        if (value = attributes[:'flowIds']).is_a?(Array)
          self.flow_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowOutcomeIds')
        
        if (value = attributes[:'flowOutcomeIds']).is_a?(Array)
          self.flow_outcome_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowOutcomeValues')
        
        if (value = attributes[:'flowOutcomeValues']).is_a?(Array)
          self.flow_outcome_values = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowDestinationTypes')
        
        if (value = attributes[:'flowDestinationTypes']).is_a?(Array)
          self.flow_destination_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowDisconnectReasons')
        
        if (value = attributes[:'flowDisconnectReasons']).is_a?(Array)
          self.flow_disconnect_reasons = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowTypes')
        
        if (value = attributes[:'flowTypes']).is_a?(Array)
          self.flow_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowEntryTypes')
        
        if (value = attributes[:'flowEntryTypes']).is_a?(Array)
          self.flow_entry_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowEntryReasons')
        
        if (value = attributes[:'flowEntryReasons']).is_a?(Array)
          self.flow_entry_reasons = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowVersions')
        
        if (value = attributes[:'flowVersions']).is_a?(Array)
          self.flow_versions = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'groupIds')
        
        if (value = attributes[:'groupIds']).is_a?(Array)
          self.group_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'hasJourneyCustomerId')
        
        
        self.has_journey_customer_id = attributes[:'hasJourneyCustomerId']
        
      
      end

      
      if attributes.has_key?(:'hasJourneyActionMapId')
        
        
        self.has_journey_action_map_id = attributes[:'hasJourneyActionMapId']
        
      
      end

      
      if attributes.has_key?(:'hasJourneyVisitId')
        
        
        self.has_journey_visit_id = attributes[:'hasJourneyVisitId']
        
      
      end

      
      if attributes.has_key?(:'hasMedia')
        
        
        self.has_media = attributes[:'hasMedia']
        
      
      end

      
      if attributes.has_key?(:'roleIds')
        
        if (value = attributes[:'roleIds']).is_a?(Array)
          self.role_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'reportsTos')
        
        if (value = attributes[:'reportsTos']).is_a?(Array)
          self.reports_tos = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'locationIds')
        
        if (value = attributes[:'locationIds']).is_a?(Array)
          self.location_ids = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'flowOutTypes')
        
        if (value = attributes[:'flowOutTypes']).is_a?(Array)
          self.flow_out_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'providerList')
        
        if (value = attributes[:'providerList']).is_a?(Array)
          self.provider_list = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'callbackNumberList')
        
        if (value = attributes[:'callbackNumberList']).is_a?(Array)
          self.callback_number_list = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'callbackInterval')
        
        
        self.callback_interval = attributes[:'callbackInterval']
        
      
      end

      
      if attributes.has_key?(:'usedRoutingTypes')
        
        if (value = attributes[:'usedRoutingTypes']).is_a?(Array)
          self.used_routing_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'requestedRoutingTypes')
        
        if (value = attributes[:'requestedRoutingTypes']).is_a?(Array)
          self.requested_routing_types = value
        end
        
        
      
      end

      
      if attributes.has_key?(:'hasAgentAssistId')
        
        
        self.has_agent_assist_id = attributes[:'hasAgentAssistId']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          media_types == o.media_types &&
          queue_ids == o.queue_ids &&
          skill_ids == o.skill_ids &&
          skill_groups == o.skill_groups &&
          language_ids == o.language_ids &&
          language_groups == o.language_groups &&
          directions == o.directions &&
          originating_directions == o.originating_directions &&
          wrap_up_codes == o.wrap_up_codes &&
          dnis_list == o.dnis_list &&
          session_dnis_list == o.session_dnis_list &&
          filter_queues_by_user_ids == o.filter_queues_by_user_ids &&
          filter_users_by_queue_ids == o.filter_users_by_queue_ids &&
          user_ids == o.user_ids &&
          address_tos == o.address_tos &&
          address_froms == o.address_froms &&
          outbound_campaign_ids == o.outbound_campaign_ids &&
          outbound_contact_list_ids == o.outbound_contact_list_ids &&
          contact_ids == o.contact_ids &&
          external_contact_ids == o.external_contact_ids &&
          external_org_ids == o.external_org_ids &&
          ani_list == o.ani_list &&
          durations_milliseconds == o.durations_milliseconds &&
          acd_durations_milliseconds == o.acd_durations_milliseconds &&
          talk_durations_milliseconds == o.talk_durations_milliseconds &&
          acw_durations_milliseconds == o.acw_durations_milliseconds &&
          handle_durations_milliseconds == o.handle_durations_milliseconds &&
          hold_durations_milliseconds == o.hold_durations_milliseconds &&
          abandon_durations_milliseconds == o.abandon_durations_milliseconds &&
          evaluation_score == o.evaluation_score &&
          evaluation_critical_score == o.evaluation_critical_score &&
          evaluation_form_ids == o.evaluation_form_ids &&
          evaluated_agent_ids == o.evaluated_agent_ids &&
          evaluator_ids == o.evaluator_ids &&
          transferred == o.transferred &&
          abandoned == o.abandoned &&
          answered == o.answered &&
          message_types == o.message_types &&
          division_ids == o.division_ids &&
          survey_form_ids == o.survey_form_ids &&
          survey_total_score == o.survey_total_score &&
          survey_nps_score == o.survey_nps_score &&
          mos == o.mos &&
          survey_question_group_score == o.survey_question_group_score &&
          survey_promoter_score == o.survey_promoter_score &&
          survey_form_context_ids == o.survey_form_context_ids &&
          conversation_ids == o.conversation_ids &&
          sip_call_ids == o.sip_call_ids &&
          is_ended == o.is_ended &&
          is_surveyed == o.is_surveyed &&
          survey_scores == o.survey_scores &&
          promoter_scores == o.promoter_scores &&
          is_campaign == o.is_campaign &&
          survey_statuses == o.survey_statuses &&
          conversation_properties == o.conversation_properties &&
          is_blind_transferred == o.is_blind_transferred &&
          is_consulted == o.is_consulted &&
          is_consult_transferred == o.is_consult_transferred &&
          remote_participants == o.remote_participants &&
          flow_ids == o.flow_ids &&
          flow_outcome_ids == o.flow_outcome_ids &&
          flow_outcome_values == o.flow_outcome_values &&
          flow_destination_types == o.flow_destination_types &&
          flow_disconnect_reasons == o.flow_disconnect_reasons &&
          flow_types == o.flow_types &&
          flow_entry_types == o.flow_entry_types &&
          flow_entry_reasons == o.flow_entry_reasons &&
          flow_versions == o.flow_versions &&
          group_ids == o.group_ids &&
          has_journey_customer_id == o.has_journey_customer_id &&
          has_journey_action_map_id == o.has_journey_action_map_id &&
          has_journey_visit_id == o.has_journey_visit_id &&
          has_media == o.has_media &&
          role_ids == o.role_ids &&
          reports_tos == o.reports_tos &&
          location_ids == o.location_ids &&
          flow_out_types == o.flow_out_types &&
          provider_list == o.provider_list &&
          callback_number_list == o.callback_number_list &&
          callback_interval == o.callback_interval &&
          used_routing_types == o.used_routing_types &&
          requested_routing_types == o.requested_routing_types &&
          has_agent_assist_id == o.has_agent_assist_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [media_types, queue_ids, skill_ids, skill_groups, language_ids, language_groups, directions, originating_directions, wrap_up_codes, dnis_list, session_dnis_list, filter_queues_by_user_ids, filter_users_by_queue_ids, user_ids, address_tos, address_froms, outbound_campaign_ids, outbound_contact_list_ids, contact_ids, external_contact_ids, external_org_ids, ani_list, durations_milliseconds, acd_durations_milliseconds, talk_durations_milliseconds, acw_durations_milliseconds, handle_durations_milliseconds, hold_durations_milliseconds, abandon_durations_milliseconds, evaluation_score, evaluation_critical_score, evaluation_form_ids, evaluated_agent_ids, evaluator_ids, transferred, abandoned, answered, message_types, division_ids, survey_form_ids, survey_total_score, survey_nps_score, mos, survey_question_group_score, survey_promoter_score, survey_form_context_ids, conversation_ids, sip_call_ids, is_ended, is_surveyed, survey_scores, promoter_scores, is_campaign, survey_statuses, conversation_properties, is_blind_transferred, is_consulted, is_consult_transferred, remote_participants, flow_ids, flow_outcome_ids, flow_outcome_values, flow_destination_types, flow_disconnect_reasons, flow_types, flow_entry_types, flow_entry_reasons, flow_versions, group_ids, has_journey_customer_id, has_journey_action_map_id, has_journey_visit_id, has_media, role_ids, reports_tos, location_ids, flow_out_types, provider_list, callback_number_list, callback_interval, used_routing_types, requested_routing_types, has_agent_assist_id].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
