=begin
PureCloud Platform API

With the PureCloud Platform API, you can control all aspects of your PureCloud environment. With the APIs you can access the system configuration, manage conversations and more.

OpenAPI spec version: v2
Contact: DeveloperEvangelists@genesys.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

License: UNLICENSED
https://help.mypurecloud.com/articles/terms-and-conditions/

Terms of Service: https://help.mypurecloud.com/articles/terms-and-conditions/

=end

require 'date'

module PureCloud
  # Activity configured for shift in work plan
  class WorkPlanActivity
    # ID of the activity code associated with this activity
    attr_accessor :activity_code_id

    # Description of the activity
    attr_accessor :description

    # Length of the activity in minutes
    attr_accessor :length_minutes

    # Whether the start time of the activity is relative to the start time of the shift it belongs to
    attr_accessor :start_time_is_relative_to_shift_start

    # Whether the start time of the activity is flexible
    attr_accessor :flexible_start_time

    # Earliest activity start in offset minutes relative to shift start time if startTimeIsRelativeToShiftStart == true else its based on midnight. Used if flexibleStartTime == true
    attr_accessor :earliest_start_time_minutes

    # Latest activity start in offset minutes relative to shift start time if startTimeIsRelativeToShiftStart == true else its based on midnight. Used if flexibleStartTime == true
    attr_accessor :latest_start_time_minutes

    # Exact activity start in offset minutes relative to shift start time if startTimeIsRelativeToShiftStart == true else its based on midnight. Used if flexibleStartTime == false
    attr_accessor :exact_start_time_minutes

    # Increment in offset minutes that would contribute to different possible start times for the activity
    attr_accessor :start_time_increment_minutes

    # Whether the activity is paid
    attr_accessor :counts_as_paid_time

    # Whether the activity duration is counted towards contiguous work time
    attr_accessor :counts_as_contiguous_work_time

    # ID of the activity. This is required only for the case of updating an existing activity
    attr_accessor :id

    # If marked true for updating an existing activity, the activity will be permanently deleted
    attr_accessor :delete

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        
        :'activity_code_id' => :'activityCodeId',
        
        :'description' => :'description',
        
        :'length_minutes' => :'lengthMinutes',
        
        :'start_time_is_relative_to_shift_start' => :'startTimeIsRelativeToShiftStart',
        
        :'flexible_start_time' => :'flexibleStartTime',
        
        :'earliest_start_time_minutes' => :'earliestStartTimeMinutes',
        
        :'latest_start_time_minutes' => :'latestStartTimeMinutes',
        
        :'exact_start_time_minutes' => :'exactStartTimeMinutes',
        
        :'start_time_increment_minutes' => :'startTimeIncrementMinutes',
        
        :'counts_as_paid_time' => :'countsAsPaidTime',
        
        :'counts_as_contiguous_work_time' => :'countsAsContiguousWorkTime',
        
        :'id' => :'id',
        
        :'delete' => :'delete'
        
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        
        :'activity_code_id' => :'String',
        
        :'description' => :'String',
        
        :'length_minutes' => :'Integer',
        
        :'start_time_is_relative_to_shift_start' => :'BOOLEAN',
        
        :'flexible_start_time' => :'BOOLEAN',
        
        :'earliest_start_time_minutes' => :'Integer',
        
        :'latest_start_time_minutes' => :'Integer',
        
        :'exact_start_time_minutes' => :'Integer',
        
        :'start_time_increment_minutes' => :'Integer',
        
        :'counts_as_paid_time' => :'BOOLEAN',
        
        :'counts_as_contiguous_work_time' => :'BOOLEAN',
        
        :'id' => :'String',
        
        :'delete' => :'BOOLEAN'
        
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      
      if attributes.has_key?(:'activityCodeId')
        
        
        self.activity_code_id = attributes[:'activityCodeId']
        
      
      end

      
      if attributes.has_key?(:'description')
        
        
        self.description = attributes[:'description']
        
      
      end

      
      if attributes.has_key?(:'lengthMinutes')
        
        
        self.length_minutes = attributes[:'lengthMinutes']
        
      
      end

      
      if attributes.has_key?(:'startTimeIsRelativeToShiftStart')
        
        
        self.start_time_is_relative_to_shift_start = attributes[:'startTimeIsRelativeToShiftStart']
        
      
      end

      
      if attributes.has_key?(:'flexibleStartTime')
        
        
        self.flexible_start_time = attributes[:'flexibleStartTime']
        
      
      end

      
      if attributes.has_key?(:'earliestStartTimeMinutes')
        
        
        self.earliest_start_time_minutes = attributes[:'earliestStartTimeMinutes']
        
      
      end

      
      if attributes.has_key?(:'latestStartTimeMinutes')
        
        
        self.latest_start_time_minutes = attributes[:'latestStartTimeMinutes']
        
      
      end

      
      if attributes.has_key?(:'exactStartTimeMinutes')
        
        
        self.exact_start_time_minutes = attributes[:'exactStartTimeMinutes']
        
      
      end

      
      if attributes.has_key?(:'startTimeIncrementMinutes')
        
        
        self.start_time_increment_minutes = attributes[:'startTimeIncrementMinutes']
        
      
      end

      
      if attributes.has_key?(:'countsAsPaidTime')
        
        
        self.counts_as_paid_time = attributes[:'countsAsPaidTime']
        
      
      end

      
      if attributes.has_key?(:'countsAsContiguousWorkTime')
        
        
        self.counts_as_contiguous_work_time = attributes[:'countsAsContiguousWorkTime']
        
      
      end

      
      if attributes.has_key?(:'id')
        
        
        self.id = attributes[:'id']
        
      
      end

      
      if attributes.has_key?(:'delete')
        
        
        self.delete = attributes[:'delete']
        
      
      end

      
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      
      
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
    end

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          activity_code_id == o.activity_code_id &&
          description == o.description &&
          length_minutes == o.length_minutes &&
          start_time_is_relative_to_shift_start == o.start_time_is_relative_to_shift_start &&
          flexible_start_time == o.flexible_start_time &&
          earliest_start_time_minutes == o.earliest_start_time_minutes &&
          latest_start_time_minutes == o.latest_start_time_minutes &&
          exact_start_time_minutes == o.exact_start_time_minutes &&
          start_time_increment_minutes == o.start_time_increment_minutes &&
          counts_as_paid_time == o.counts_as_paid_time &&
          counts_as_contiguous_work_time == o.counts_as_contiguous_work_time &&
          id == o.id &&
          delete == o.delete
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [activity_code_id, description, length_minutes, start_time_is_relative_to_shift_start, flexible_start_time, earliest_start_time_minutes, latest_start_time_minutes, exact_start_time_minutes, start_time_increment_minutes, counts_as_paid_time, counts_as_contiguous_work_time, id, delete].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = Object.const_get("PureCloud").const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
